<?php
$box_typeInfo =  
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "title"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "list",
                "sorta"
            ),
            "idx"=>array(
                "type"=>"INT",
                "unsigned",
                "not null",
                "list",
                "sorta"
            ),
            "style"=>array(
                "type"  =>"ENUM",
                "values"=>array( "framed", "general" ),
                "not null",
                "list"
            ),
            "forumId"=>array(
                "type"=>"INT",
                "not null"
            ),
            "forumName"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "form invisible",
                "no column",
                "list"
            ),
            "alignment"=>array(
                "type"  =>"ENUM",
                "values"=>array( "left", "right" ),
                "not null",
                "list",
                "sorta"
            ),
            "contentType"=>array(
                "type"  =>"ENUM",
                "values"=>array( "HTML", "Php4", "Poll" ),
                "not null",
                "list"
            ),            
            "content"=>array(
                "type"=>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null"
            ),
            "status"=>array(
                "type"  =>"ENUM",
                "values"=>array( "enabled", "disabled" ),
                "not null",
                "list",
                "sorta"
            ),
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )
        ),
        "primary_key"=>"id",
        "tableName"=>"box_zorum"
    );
class Box extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumuser;
        global $generalRight;
        $generalRight = TRUE;
        $hasRight = ($zorumrecognised && $zorumuser->isAdm=="yes");
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function generForm(&$s)
    {
        global $langTxt,$infoText;
        global $box_typeInfo;
        global $zorumroll;
        $forums = new Forum;
        $query="SELECT id, name FROM forum_zorum ".
               "WHERE portalNews='yes' ORDER BY treeidx";
        $ret=loadObjectsSQL( $forums,$query,$forums);
        if ($ret==general_mysql_error) {
            return $ret;
        }
        $typ = & $box_typeInfo;
        $typ["attributes"]["forumId"]["type"] = "ENUM";
        $typ["attributes"]["forumId"]["values"][-1] = -1;
        $typ["attributes"]["forumId"]["values"][0] = 0;
        foreach( $forums as $forum )
        {
            $typ["attributes"]["forumId"]["values"][$forum->id] = 
                $forum->id;
            $langTxt["box_forumId_$forum->id"]=$forum->name;   
        }  
        $ret = Object::generForm($s);
        return $ret;
    }
    function loadHtmlList(&$boxList)
    {
        global $langTxt;
        $ret = Object::loadHtmlList($boxList);
        if ($ret==not_found_in_db) {
            return ok;
        }
        elseif( $ret ) {
            return $ret;
        }
        $forums = new Forum;
        $query = "SELECT id, name FROM forum_zorum WHERE portalNews='yes'";
        $ret = loadObjectsSql( $forums, $query, $forums );
        if ($ret==general_mysql_error) {
            return $ret;
        }
        $forumNames = array();
        $forumNames["-1"] = $langTxt["box_-1"];
        $forumNames[0] = $langTxt["box_0"];
        foreach( $forums as $forum ) 
        {
            $forumNames[$forum->id]=$forum->name;
        }
        for( $i=0; isset($boxList[$i]); $i++ )
        {
            $boxList[$i]->forumName =$forumNames[$boxList[$i]->forumId];
        }        
        return ok;
    }
    function showDetails( &$s, $whereFields)
    {
        global $zorumroll;
        global $langTxt;
        global $box_typeInfo;
        $this->id = $zorumroll->rollid;
        $ret=$this->load();    
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["not_found_deleted"];
            return ok;
        }
        if ($ret!=ok) {
            return $ret;
        }
        if( $this->forumId>0 )
        {
            $forum = new Forum;
            $forum->id = $this->forumId;
            $ret = load($forum, "", "name");
            if ($ret!=ok) {
                return $ret;
            }
            $this->forumName = $forum->name;
        }
        elseif( $this->forumId==0 )
        {
            $this->forumName = $langTxt["box_0"];
        }
        else $this->forumName = $langTxt["box_-1"];
        $box_typeInfo["attributes"]["forumId"][]="no column";
        $ret = Object::showDetails($s, $whereFields, FALSE);
        return $ret;
    }
    function delete($whereFields="",$overrulePrivilege=FALSE)
    {
        global $submit;
        global $langTxt;
        global $whatHappened;
        global $infoText;
        global $zorumroll;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["no"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $ret=privilegeDelete($this,$whereFields="",$overrulePrivilege);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["no_such_object"];
            return ok;
        }
        if ($ret!=ok) {
            return $ret;
        }
        if( $zorumroll->frommethod=="showdetails" )      
        {
            $zorumroll->frommethod = "showhtmllist";
            $zorumroll->fromid = 0;
        }
        return ok;     
    }  
    function showNavBar(&$s)
    {
        global $zorumroll; 
        global $langTxt;
        $s = "";
        goForward( $tempRoll, "forums" );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
        $s.="&nbsp;>&nbsp;";
        if( $zorumroll->method=="showhtmllist" )
        {
            $s.=$langTxt["boxes"];
        }
        else
        {
            goForward( $tempRoll, "boxes", $this );
            $s.=$tempRoll->generAnchor($langTxt["boxes"]);
        }    
        $s=insertSpanClass( $s, "navBar" );
        return ok;
    }
    function showNewTool(&$s, $rights)
    {
        global $langTxt;
        $s="";
        if (!isset($rights[Priv_create])) {
            $ret=$this->hasObjectRights($hasRight,Priv_create);
            if ($ret!=ok) {
                return $ret;
            }
        }
        else $hasRight = $rights[Priv_create];
        if ($hasRight) {
            goForward( $tempRoll, "create" );
            $s.=$tempRoll->generAnchor($langTxt["box_newitem"], 
                                       "command");
            $s.="<br>";
            $tempRoll->method = "create_pollbox_form";
            $s.=$tempRoll->generAnchor($langTxt["pollbox_newitem"], 
                                       "command");
            $s.="<p>";
        }
    }
    function createPollboxForm(&$s)
    {
        global $langTxt;
        global $box_typeInfo;
        $ret=$this->hasObjectRights($hasRight, Priv_create, TRUE);
        if ($ret!=ok) 
        {
            return $ret;
        }
        $polls = new Poll;
        $query="SELECT p.id, f.id AS forumId, question FROM ".
               "poll_zorum AS p, forum_zorum AS f ".
               "WHERE p.pid='0' OR (p.pid=f.id AND f.portalNews='yes')";
        $ret=loadObjectsSQL( $polls,$query,$polls);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["noPollToSelect"];
            return ok;
        }
        elseif( $ret ) {
            return $ret;
        }
        $typ = & $box_typeInfo;
        $typ["attributes"]["title"]["type"] = "ENUM";
        foreach( $polls as $poll )
        {
            $typ["attributes"]["title"]["values"][$poll->id] = 
                $poll->id;
            $langTxt["box_title_$poll->id"]=$poll->question;   
        }  
        $typ["attributes"]["style"][]="form invisible";
        $typ["attributes"]["contentType"][]="form invisible";
        $typ["attributes"]["content"][]="form invisible";
        $langTxt["box_title"] = $langTxt["boxTitle"];
        $ret=$this->generForm($s);
        return ok;
    }
    function createForm(&$s)
    {
        global $langTxt;
        global $box_typeInfo;
        $ret=$this->hasObjectRights($hasRight, Priv_create, TRUE);
        if ($ret!=ok) 
        {
            return $ret;
        }
        $typ = & $box_typeInfo;
        unset($typ["attributes"]["contentType"]["values"][2]);
        $ret=$this->generForm($s);
        return ok;
    }
    function modifyPollboxForm(&$s)
    {
        global $langTxt;
        global $box_typeInfo;
        $ret=$this->load();
        if ($ret!=ok) 
        {
            return $ret;
        }
        $ret=$this->hasObjectRights($hasRight, Priv_modify, TRUE);
        if ($ret!=ok) 
        {
            return $ret;
        }
        $polls = new Poll;
        $query="SELECT id, question FROM poll_zorum";
        $ret=loadObjectsSQL( $polls,$query,$polls);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["noPollToSelect"];
            return ok;
        }
        elseif( $ret ) {
            return $ret;
        }
        $typ = & $box_typeInfo;
        $typ["attributes"]["title"]["type"] = "ENUM";
        foreach( $polls as $poll )
        {
            $typ["attributes"]["title"]["values"][$poll->id] = 
                $poll->id;
            $langTxt["box_$poll->id"]=$poll->question;   
            if( $this->title==$poll->question ) $this->title=$poll->id;
        }  
        $typ["attributes"]["style"][]="form invisible";
        $typ["attributes"]["contentType"][]="form invisible";
        $typ["attributes"]["content"][]="form invisible";
        $langTxt["box_title"] = $langTxt["boxTitle"];
        $ret=$this->generForm($s);
        return ok;
    }
    function modifyForm(&$s)
    {
        global $langTxt;
        global $box_typeInfo;
        $ret=$this->load();
        if ($ret!=ok) 
        {
            return $ret;
        }
        $ret=$this->hasObjectRights($hasRight, Priv_modify, TRUE);
        if ($ret!=ok) 
        {
            return $ret;
        }
        $typ = & $box_typeInfo;
        unset($typ["attributes"]["contentType"]["values"][2]);
        $ret=$this->generForm($s);
        return ok;
    }
    function createPollbox()
    {
        global $langTxt;
        $poll = new Poll;
        $poll->id = $this->title;
        $ret=load( $poll,"","question");
        if ($ret==not_found_in_db) {
            $infoText[] = sprintf($langTxt["noSuchPoll"], $this->title);
            return ok;
        }
        elseif( $ret ) {
            return $ret;
        }
        $this->title = $poll->question;
        $this->style="general";
        $this->contentType="Poll";
        $this->content="showPoll(\$content, $poll->id);";
        $ret=privilegeCreate($this);
        return $ret;
    }
    function modifyPollbox()
    {
        global $langTxt;
        $poll = new Poll;
        $poll->id = $this->title;
        $ret=load( $poll,"","question");
        if ($ret==not_found_in_db) {
            $infoText[] = sprintf($langTxt["noSuchPoll"], $this->title);
            return ok;
        }
        elseif( $ret ) {
            return $ret;
        }
        $this->title = $poll->question;
        $this->style="general";
        $this->contentType="Poll";
        $this->content="showPoll(\$content, $poll->id);";
        $ret=privilegeModify($this);
        return $ret;
    }
    function showModTool(&$s, $rights)
    {
        global $langTxt;
        $s="";
        if (!isset($rights[Priv_modify])) {
            $ret=$this->hasObjectRights($hasRight,Priv_modify);
            if ($ret!=ok) {
                return $ret;
            }
        }
        else $hasRight = $rights[Priv_modify];
        if ($hasRight) {    
            goForward( $tempRoll, "modify" );
            $tempRoll->id = $this->id;
            if( $this->contentType=="Poll" ) 
            {
                $tempRoll->method="modify_pollbox_form";
            }    
            $s.=$tempRoll->generImageAnchor("i/edit.gif",
                                       $langTxt["icon_modify"],20,20);
        }
        return ok;
    }
}
?>