<?php
$fontstyle_typeInfo = 
    array(
        "attributes"=>array(   
            "font_family"=>array(
                "type"=>"VARCHAR",
                "max" =>"50"
            ),
            "font_style"=>array(
                "type"=>"ENUM",
                "values"=>array( "not defined", "normal", "italic", 
                                 "oblique" )
            ),
            "font_variant"=>array(
                "type"=>"ENUM",
                "values"=>array( "not defined", "normal", "small-caps" )
            ),
            "font_weight"=>array(
                "type"=>"ENUM",
                "values"=>array( "not defined", "normal", "bold", 
                                 "bolder", "lighter", 
                                 "100", "200", "300", "400", "500", 
                                 "600", "700", "800", "900" )
            ),
            "font_size"=>array(
                "type"=>"ENUM",
                "values"=>array( "not defined", "xx-small", "x-small", 
                                 "small", "medium", "large", "x-large", 
                                 "xx-large", "larger", "smaller" )
            ),
            "font_size_spec"=>array(
                "type"=>"VARCHAR",
                "max" =>"10",
            )       
        )
    );
class FontStyle extends Object
{
    function init()
    {
        $this->font_family = "";
        $this->font_style = "not defined";
        $this->font_variant = "not defined";
        $this->font_weight = "not defined";
        $this->font_size = "not defined";
        $this->font_size_spec = "";
        return ok;
    }
    function modifyFontStyleForm(&$s)
    {
        global $zorumroll;
        global $zorumfontstylesheet;
        global $styleitem;
        global $langTxt;
        global $HTTP_GET_VARS;
        $s = "";
        $zorumroll = new Roll;
        foreach($HTTP_GET_VARS as $key=>$val) 
        {
            if( $key!="x" && $key!="u" ) $zorumroll->{$key}=stripslashes($val);
        }
        $zorumroll->scriptname = "z_stylesheet_form.php";
        $this->init();
        $this->str2fontStyle( $zorumfontstylesheet->{$styleitem} );
        $langTxt["fontstyle_modifyfontstyle_form"].=": ".
            $langTxt["stylesheet_$styleitem"];
        $ret=$this->generForm($s);
        if ($ret!=ok) 
        {
            return $ret;
        }
        return ok;
    }
    function modifyFontStyle(&$s)
    {
        global $langTxt;
        global $zorumfontstylesheet;
        global $styleitem;
        global $submit;
        global $whatHappened;
        global $zorumroll;
        if( $submit==$langTxt["cancel"] )
        {   
            $zorumroll->class = "stylesheet";
            $zorumroll->method="modify";
            $whatHappened = "reset_form";
            return ok;
        }
        $this->fontStyle2str( $zorumfontstylesheet->{$styleitem} );
        $ret = $zorumfontstylesheet->modify();
        if ($ret || $whatHappened=="invalid_form") {
            return $ret;
        }
        $zorumroll->class = "stylesheet";
        $zorumroll->method="modify";
        $whatHappened = "reset_form";
        return ok;
    }
    function str2fontStyle( $s, $fullString=FALSE )
    {
        global $fontstyle_typeInfo;
        $fields = explode( ";", $s);
        foreach( $fields as $field )
        {
            $pair = explode( ":", $field);
            if( isset($pair[0]) && isset($pair[1]) )
            {
                $pair[0] = trim(str_replace( "-", "_", $pair[0] ));
                $pair[1] = trim($pair[1]);
                $this->{$pair[0]} = $pair[1];
            }    
        }
        $typ = $this->getTypeInfo();
        $attrs = $typ["attributes"];
        foreach( $attrs as $attr=>$attrInfo )
        {
            if( $attrInfo["type"]=="ENUM" && isset($this->{$attr}) &&
                !in_array( $this->{$attr}, $attrInfo["values"] ) )
            {
                if( $attr=="font_size" ) 
                {
                    $this->font_size_spec=$this->font_size;
                }    
                $this->{$attr}="not defined";
            }    
        }
        if( !$fullString )
        {
            $object_vars = get_object_vars($this);
            foreach( $object_vars as $attr=>$value )
            {
                if( !isset($attrs[$attr]) ) unset( $this->{$attr} );
            }
        }
        return ok;
    }
    function fontStyle2str( &$s )
    {
        global $fontstyle_typeInfo;
        $temp = new FontStyle;
        $temp->init();
        $temp->str2fontStyle($s, TRUE);
        $object_vars = get_object_vars($this);
        foreach( $object_vars as $attr=>$value )
        {
            $temp->{$attr} = $value;
        }
        $s = "";
        if( isset($temp->font_size_spec) && $temp->font_size_spec!="" )
        {
            $temp->font_size = $temp->font_size_spec;
            unset($temp->font_size_spec);
        }
        $object_vars = get_object_vars($temp);
        foreach( $object_vars as $attr=>$value )
        {
            if($value!=""&&$value!="not defined") 
            {
                $s.=str_replace("_", "-", $attr).": $value; ";
            }
        }
        return ok;
    }
    function printFontStyle()
    {
        $object_vars = get_object_vars($this);
        echo "<br>";
        foreach( $object_vars as $attribute=>$value )
        {
            echo "$attribute: $value<br>";
        }
    }
}
?>