<?php
function forumtopic_create(&$base,$overrulePrivilege=FALSE)
{
    global $zorumuser, $zorumauthlevel;
    global $whatHappened, $infoText;
    global $zorumroll;
    global $submit;
    global $langTxt;
    global $specBlockSize;
    global $usedInPortal;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    if( $submit==$langTxt["preview"] ) {   
        global $veryGlobal;
        $whatHappened = "invalid_form";
        $veryGlobal=TRUE;
        return ok;
    }        
    $ret = $base->cacheFatherObject();
    if ($ret!=ok) {
        return $ret;
    }        
    global $fatherForum;
    if (isset($base->niceurl) && $base->niceurl!="") {
        $ret=createNiceUrlTopic($base,$fatherForum,$niceFileName);
        if ($ret!=ok) {
            $whatHappened = "invalid_form";
            return ok;
        }
    }    
    $fatherForum->topicnum++;
    $base->blockPosition=ceil($fatherForum->topicnum/$specBlockSize)-1;
    $base->creator = $zorumauthlevel==Loginlib_GuestLevel ?
                     $langTxt["anonymous"] : $zorumuser->name;
    if( $usedInPortal && $fatherForum->portalNews=="yes" )
    {  
        setDisplayPeriod($base);
        if( $whatHappened=="invalid_form" ) {
            return $ret;
        }
    }  
    else
    {
        $base->displayPeriodStart = time();
        $base->displayPeriodEnd = mktime(0,0,0,1,1,2020);
    }                               
    $ret = privilegeCreate($base, $overrulePrivilege);
    if ($ret || $whatHappened=="invalid_form" ) {
        return $ret;
    }
    $message = new ForumMessage;
    $message->pid = $base->pid;
    $message->tid = $base->id;
    $message->subject = $base->subject;
    $message->coding = $base->coding;
    $message->smiley = $base->smiley;
    if( isset($base->txt) ) $message->txt = $base->txt;
    if( isset($base->descriptionTxt) ) $message->descriptionTxt = $base->descriptionTxt;
    $ret = $message->create($overrulePrivilege);
    if ($ret || $whatHappened=="invalid_form" ) {
        return $ret;
    }
    $ret = modify($fatherForum);
    if ($ret!=ok)
    {
        return $ret;
    }
    global $zorumglobalstat;
    $zorumglobalstat->topicnum++;
    $ret = modify($zorumglobalstat);
    if ($ret!=ok) {
        return $ret;
    }
    if (isset($base->subs_topic) && $base->subs_topic=="yes") {
        $subs = new Subscribe();
        $subs->type=subs_topic_new_mess;
        $subs->userid=$zorumuser->id;
        $subs->classid=$base->id;
        $ret=create($subs);
        if ($ret!=ok) {
            return $ret;
        }
    }
    $ret=sendMailToSubscribed($fatherForum,$base,$message,$zorumuser,
                              "topic");
    if ($ret!=ok) {
        return $ret;
    }
    global $searchEngine;
    if( $searchEngine=="yes" && $fatherForum->readgroup==0 )
    {    
        $remainder = $fatherForum->topicnum % $specBlockSize;
        if ($remainder==0) $remainder=$specBlockSize;
        $navbar="<a href='forum.html'>".$langTxt["forums"]."</a>";
        $navbar.=" &gt; ";
        $navbar.=htmlspecialchars($fatherForum->name);
        $ret=specTopic($base->pid,$navbar,$base->blockPosition,
                    0,$remainder,FALSE);
        if ($ret!=ok) {
            return $ret;
        }
        if( $remainder==1 ) 
        {
            if( $base->blockPosition>0 )
            {
                $ret=specTopic($base->pid,$navbar,
                               $base->blockPosition-1,
                               1,$specBlockSize+1,TRUE);
                if ($ret!=ok) {
                    return $ret;
                }
            }
        }
    }
    if (isset($base->niceurl) && $base->niceurl!="") {
        $ret=writeNiceUrl($message->id,$niceFileName,TRUE);
        if ($ret!=ok) {
            $infoText[] = $langTxt["nice_err"];
            return ok;
        }
    }    
    if( isset($base->poll) && $base->poll=="yes" )
    {
        $whatHappened = "reset_form";
        $zorumroll->method = "create";
        $zorumroll->class = "poll";
        $zorumroll->pid = $base->pid;
        $zorumroll->tid = $base->id;
        $zorumroll->creator = $base->creator;
        $zorumroll->scriptname = "z_poll_form.php";
    }    
    $infoText[] = sprintf($langTxt["created"], 
                          $langTxt["forumtopic"]);
    return ok;     
} 
function forumtopic_modify(&$base, $whereFields="", $overrulePrivilege=FALSE )
{
    global $submit;
    global $whatHappened, $infoText;
    global $langTxt;
    global $searchEngine;
    global $specBlockSize;
    global $usedInPortal;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    if( $submit==$langTxt["preview"] ) {   
        global $veryGlobal;
        $whatHappened = "invalid_form";
        $veryGlobal=TRUE;
        return ok;
    }        
    $origTopic = new ForumTopic;
    $origTopic->id=$base->id;
    $ret=$origTopic->load();
    if ($ret!=ok) {
        return $ret;
    }
    $ret = $base->cacheFatherObject();
    if ($ret!=ok) {
        return $ret;
    }        
    global $fatherForum;
    if (isset($base->niceurl) && $base->niceurl!="") {
        $ret=createNiceUrlTopic($base,$fatherForum,$niceFileName);
        if ($ret==wrong_object) {
            $whatHappened="";
            $infoText[count($infoText)-1]="";
        }        
        elseif ($ret!=ok) {
            $whatHappened = "invalid_form";
            return ok;
        }
    } 
    if( $usedInPortal && $fatherForum->portalNews=="yes" )
    {  
        setDisplayPeriod($base);
        if( $whatHappened=="invalid_form" ) {
            return $ret;
        }
    }  
    $ret = privilegeModify( $base, $whereFields,$overrulePrivilege);
    if ($ret || $whatHappened=="invalid_form" ) {
        return $ret;
    }
    $firstMessage = new ForumMessage;
    $firstMessage->tid = $base->id;    
    $firstMessage->pid = $base->pid;    
    $firstMessage->up = 0;    
    $ret = load( $firstMessage, array("tid", "pid", "up") );
    if ($ret!=ok) {
        return $ret;
    }
    if( $firstMessage->subject!=$base->subject || 
        isset($firstMessage->txt) && isset($base->txt) &&
        $firstMessage->txt!=$base->txt ||
        isset($base->txt) && !isset($firstMessage->txt)|| 
        isset($firstMessage->descriptionTxt) && isset($base->descriptionTxt) &&
        $firstMessage->descriptionTxt!=$base->descriptionTxt ||
        isset($base->descriptionTxt) && !isset($firstMessage->descriptionTxt) ||
        $firstMessage->coding!=$base->coding || 
        $firstMessage->smiley!=$base->smiley)
    {
        $firstMessage->subject = $base->subject;
        $firstMessage->txt = $base->txt;
        $firstMessage->coding = $base->coding;
        $firstMessage->smiley = $base->smiley;
        if( isset($base->descriptionTxt) ) $firstMessage->descriptionTxt = $base->descriptionTxt;
        $ret = modify( $firstMessage );
        if ($ret!=ok) {
            return $ret;
        }
        if( $searchEngine=="yes" && $fatherForum->readgroup==0 )
        {    
            $remainder = $base->postnum % $specBlockSize;
            if ($remainder==0) $remainder=$specBlockSize;
            $navbar="<a href='forum.html'>".$langTxt["forums"]."</a>";
            $navbar.=" &gt; ";
            $b = $base->blockPosition;
            $navbar.="<a href='".$base->pid."_topic_$b.html'>".
                    htmlspecialchars($fatherForum->name)."</a>";
            $navbar.=" &gt; ";
            $navbar.=htmlspecialchars($base->subject);
            $ret=specMessage($base->pid,$base->id,$navbar,0,0,
                             $specBlockSize,FALSE);
            if ($ret!=ok) {
                return $ret;
            }
        }
    }
    if( $searchEngine=="yes" && $fatherForum->readgroup==0 )
    {    
        $navbar="<a href='forum.html'>".$langTxt["forums"]."</a>";
        $navbar.=" &gt; ";
        $navbar.=htmlspecialchars($fatherForum->name);
        $maxBlock=ceil($fatherForum->topicnum/$specBlockSize)-1;
        $remainder = $fatherForum->topicnum % $specBlockSize;
        $helpInt = $remainder ? 1 : 0;
        $forceNextButton = ($base->blockPosition<$maxBlock);
        $offset=max(($maxBlock-$base->blockPosition-$helpInt)*$specBlockSize+$remainder,0);
        $range=($base->blockPosition==$maxBlock&&$remainder)?$remainder:$specBlockSize;
        $ret=specTopic($base->pid,$navbar,$base->blockPosition,
                       $offset, $offset+$range, $forceNextButton);
        if ($ret!=ok) {
            return $ret;
        }
    }    
    if (isset($niceFileName) && 
        $base->wholeniceurl!=$origTopic->wholeniceurl)
    {
        $ret=writeNiceUrl($firstMessage->id,$niceFileName,TRUE);
        if ($ret!=ok) {
            $infoText[] = $langTxt["nice_err"];
            return ok;
        }
        if ($origTopic->niceurl!="") {
            if (strstr($origTopic->wholeniceurl,".")) {
                $ret=unlink($origTopic->wholeniceurl);
            }
            else {
                $fil=$origTopic->wholeniceurl."/index.php";
                $ret=unlink($fil);
                $ret=rmdir($origTopic->wholeniceurl);
            }
        }
    }    
}
function setDisplayPeriod(&$base)
{
    global $whatHappened, $infoText, $langTxt;
    if( !checkdate($base->displayPeriodStart_month,
                   $base->displayPeriodStart_day,
                   $base->displayPeriodStart_year) )
    {
        $infoText[]=$langTxt["invalidStartDate"];
        $whatHappened = "invalid_form";
        return ok;
    }               
    if( !checkdate($base->displayPeriodEnd_month,
                   $base->displayPeriodEnd_day,
                   $base->displayPeriodEnd_year) )
    {
        $infoText[]=$langTxt["invalidEndDate"];
        $whatHappened = "invalid_form";
        return ok;
    }               
    $base->displayPeriodStart = mktime(0,0,0,
                                       $base->displayPeriodStart_month,
                                       $base->displayPeriodStart_day,
                                       $base->displayPeriodStart_year);
    $base->displayPeriodEnd = mktime(0,0,0,
                                     $base->displayPeriodEnd_month,
                                     $base->displayPeriodEnd_day,
                                     $base->displayPeriodEnd_year);
    if( $base->displayPeriodEnd < $base->displayPeriodStart )
    {
        $infoText[]=$langTxt["endDateMustBeGreaterThanStartDate"];
        $whatHappened = "invalid_form";
        return ok;
    }                            
}
function forumtopic_delete(&$base, $whereFields="", $overrulePrivilege=FALSE )
{
    global $submit;
    global $langTxt;
    global $whatHappened, $infoText;
    global $zorumroll;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["no"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $ret = privilegeDelete( $base,$whereFields, $overrulePrivilege);
    if ($ret || $whatHappened=="invalid_form" ) {
        $infoText[] = $langTxt["no_such_object"];
        return ok;
    }  
    if( $base->poll=="yes" )
    {
        $poll = new Poll;
        $poll->tid = $base->id;
        $ret = load($poll, array("tid"));
        if ($ret!=ok) {
            return $ret;
        }
        $ret = $poll->delete("",TRUE);
        if ($ret!=ok) {
            return $ret;
        }
    }      
    global $fatherForum;
    $fatherForum=0; 
    $ret = $base->cacheFatherObject();
    if ($ret!=ok) {
        return $ret;
    }        
    if ($fatherForum) {        
        $fatherForum->topicnum--;
        if ($fatherForum->topicnum==0) $fatherForum->lastpost=0;
        $ret = modify($fatherForum);
        if ($ret!=ok) {
            return $ret;
        }
    }
    global $zorumglobalstat;
    $zorumglobalstat->topicnum--;
    $ret = modify($zorumglobalstat);
    if ($ret!=ok) {
        return $ret;
    }
    $firstMessage = new ForumMessage;
    $firstMessage->tid = $base->id;    
    $firstMessage->pid = $base->pid;    
    $firstMessage->up = 0;    
    $ret = $firstMessage->load(array("tid", "pid", "up"));
    if ($ret!=ok && $ret!=not_found_in_db) {        
        return $ret;
    }
    if ($ret==ok) {
        $ret = $firstMessage->delete();
        if ($ret!=ok && $ret!=not_found_in_db) {        
            return $ret;
        }
    }
    if( $fatherForum && $fatherForum->topicnum==0 )
    {
        if( $zorumroll->fromclass=="forumtopic" )
        {
            $zorumroll->fromclass = "forum";
            $zorumroll->frommethod = "showhtmllist";
            $zorumroll->fromscriptname = "z_forum_show.php";
            $zorumroll->fromid = 0;
        }    
    }
    elseif( $zorumroll->frommethod=="showdetails" )      
    {
        $zorumroll->frommethod = "showhtmllist";
        $zorumroll->fromid = $base->pid;
    }
    global $searchEngine;
    if( $searchEngine=="yes" && $fatherForum->readgroup==0 )
    {    
        $cmd="rm -f html/".$base->id."_message*";
        system($cmd);
        $cmd="rm -f html/".$fatherForum->id."_topic*";
        system($cmd);        
        if( $fatherForum ) 
        {       
            $settings->settings_searchEngine="yes";
            $ret = generateTopicFiles($settings, $fatherForum->id,
                                      $fatherForum->name,$topicList);
            if( $ret!=ok && $ret!=not_found_in_db ) {
                return $ret;
            }
        }
    }
    $ret = forumtopic_rewriteBlockPositions($base);
    if( $ret!=ok ) {
        return $ret;
    }
}
function forumtopic_rewriteBlockPositions($base)
{
    global $specBlockSize;
    $ret = loadSpecTopic($topicList, $base->pid);
    if( $ret!=ok && $ret!=not_found_in_db) {
        return $ret;
    }
    $topicList = array_reverse($topicList);
    $i=0;
    foreach( $topicList as $topic )
    {
        $topic->blockPosition = floor($i/$specBlockSize);
        $ret = modify($topic);
        if( $ret )
        {
            return $ret;
        }
        $i++;
    }
}   
function specTopic($pid,$navbar,$block=0,$from=0,$to=0,
                   $forceNextButton=FALSE,$hot=FALSE)
{
    global $langTxt;
    global $specBlockSize;
    if ($to==0) $to=$specBlockSize;
    $parTo=$to-$from;
    if ($hot) {
        $parTo=$specBlockSize;
    }
    $ret=loadSpecTopic($topicList,$pid,$from,$parTo,$hot);
    if ($ret!=ok&&$ret!=not_found_in_db) {
        return $ret;
    }
    $ret=showSpecTopic($topicList,$pid,$block,$navbar,$s,0,
                       $specBlockSize,$forceNextButton,$hot);
    if ($ret!=ok) {
        return $ret;
    }
    if ($pid==0) $f=fopen("html/hottopic.html","w");
    elseif ($hot) $f=fopen("html/".$pid."_hottopic.html","w");
    else $f=fopen("html/".$pid."_topic_$block.html","w");
    fwrite($f,$s);
    fclose($f);
    return ok;
}
function loadSpecTopic(&$topicList,$pid,$from=0,$to=0,$hot=FALSE)
{
    global $specBlockSize,$forumtopic_typeInfo;
    if ($hot) {
        if ($pid==0) {
            $forumtopic_typeInfo["attributes"]["forumname"][]="list";
        }
        $query="SELECT t.id AS id,subject,t.postnum AS postnum,creator".
               ",t.lastpost AS lastpost,f.name AS forumname,".
               "f.id AS pid".
               " FROM forumtopic_zorum t, forum_zorum f".
               " WHERE f.id=t.pid AND f.readgroup='0'";
        if ($pid!=0) $query.=" AND pid=$pid";
        $query.=" ORDER by lastpost DESC LIMIT 0,$specBlockSize";
    }
    else {
        $query="SELECT id,subject,postnum,creator,lastpost, blockPosition".
               " FROM forumtopic_zorum".
               " WHERE pid=$pid".
               " ORDER BY creationtime DESC";
        if( $to ) $query.=" LIMIT $from,$to";
    }
    $t = new ForumTopic;
    $ret = $t->loadObjectsSql($query,$topicList,TRUE);
    if ($ret!=ok&&$ret!=not_found_in_db) {
        return $ret;
    }    
    return $ret;
}
function showSpecTopic($topicList,$pid,$block,$navbar,&$s,$from=0,$to=0, $forceNextButton=FALSE,$hot=FALSE)
{
    global $specBlockSize;
    global $zorumSkin,$langTxt;
    $s = "";
    if ($to==0) $to=$specBlockSize;
    $tempRoll = new Roll;
    $tempRoll->scriptname = "../z_forumtopic_show.php";
    $tempRoll->method = "showhtmllist";
    if ($pid==0) $tempRoll->class = "forumtopic_newm";
    else $tempRoll->class = "forumtopic";
    if ($pid!=0) $tempRoll->rollid = $pid;
    if( $block>0 ) $prevFile = $pid."_topic_".($block-1).".html";
    else $prevFile = "";
    if (($block+1) * $specBlockSize < count($topicList) || 
        $forceNextButton) {
        $nextFile = $pid."_topic_".($block+1).".html";
    }
    else $nextFile="";
    if ($hot) $prevFile = $nextFile = 0;
    $s.=generateFileHeader($tempRoll,$navbar, $prevFile, $nextFile);
    $s.="<table border='0' width='100%' cellpadding='0'".
        " cellspacing='0'><tr><td bgcolor='".$zorumSkin->line."'>\n";
    $s.="<table border='0' width='100%' cellpadding='2' ".
        "cellspacing='1'>\n";
    $s.="<tr bgcolor='".$zorumSkin->headbg."'>";
    if ($pid==0) $s.="<th>".$langTxt["forumname"]."</th>\n";
    $s.="<th>".$langTxt["subject"]."</th>\n";
    $s.="<th>".$langTxt["postnum"]."</th>\n";
    $s.="<th>".$langTxt["creator"]."</th>\n";
    $s.="<th>".$langTxt["lastpost"]."</th>\n";
    $s.="</tr>\n";
    for( $i=$from; $i<$to && isset($topicList[$i]); $i++ ) {
        $s.="<tr bgcolor='".$zorumSkin->cellbg."'>";
        if ($pid==0) {
            $s.="<td>"."<a href='".$topicList[$i]->pid.
                "_hottopic.html'>".$topicList[$i]->forumname.
                "</a></td>\n";
        }
        $s.="<td>"."<a href='".$topicList[$i]->id."_message_0.html'>".
            htmlspecialchars($topicList[$i]->subject)."</a></td>\n";
        $s.="<td>".$topicList[$i]->postnum."</td>\n";
        $s.="<td>".htmlspecialchars($topicList[$i]->creator)."</td>\n";
        $b=ceil($topicList[$i]->postnum / $specBlockSize)-1;
        $s.="<td><a href='".$topicList[$i]->id."_message_$b.html'>".
        showTimestamp($topicList[$i]->lastpost)."</a></td>\n";
        $s.="</tr>\n";
    }
    $s.="</table>\n";
    $s.="</td></tr></table>\n";
    $s.= "<br>".showPFooter();
    $s.="</body>";
    return ok;
}
function createNiceUrlTopic(&$base,$forum,&$fname)
{
    global $whatHappened,$infoText,$langTxt;
    global $fatherForumList,$niceDepth;
    $fname="";
    $ret = $forum->cacheFatherObjects();
    if( $ret ) {
        return $ret;
    }        
    $fname="";
    $niceDepth=1;
    foreach($fatherForumList as $f) {
        $fname.=$f->niceurl."/";
        $niceDepth++;
    }
    $fname.=$forum->niceurl."/";
    $fname.=$base->niceurl;
    $base->wholeniceurl=$fname;
    if (strstr($base->niceurl,".")) {
        $f=@fopen($fname,"r");
        if ($f) {
            $whatHappened="invalid_form";
            $infoText[] = sprintf($langTxt["nice_al_ex"],$fname);
            return wrong_object;
        }
        if ($f) fclose($f);
    }
    else {
        $ret=@is_dir($fname);
        if ($ret) {
            $whatHappened="invalid_form";
            $infoText[] = sprintf($langTxt["nice_al_ex"],$fname);
            return wrong_object;
        }
        $success = @mkdir($fname, 0777);
        if( !$success ) {
            $whatHappened="invalid_form";
            $infoText[] = sprintf($langTxt["nice_create_err"],$fname);
            return ok;
        }
        $fname="$fname/index.php";
        $f=fopen($fname,"w");
        if (!$f) {
            $whatHappened="invalid_form";
            $infoText[] = sprintf($langTxt["nice_create_f_err"],$fname);
            return nok;
        }        
        fclose($f);
    }
    return ok;
}
function deleteNiceUrlTopics($pid,$url)
{
    $query="SELECT niceurl FROM forumtopic_zorum WHERE pid=$pid".
           " AND niceurl!=''";
    $result=mysql_query($query);
    if( $result==0 ) {
        $infoText[] = mysql_error();
        return general_mysql_error;
    }
    $num = mysql_num_rows($result);           
    for($i=0;$i<$num;$i++) {
        $row=mysql_fetch_row($result);
        $fname="$url/".$row[0];
        $isdir=@is_dir($fname);
        if ($isdir) {
          $fnam="$fname/index.php";
          $ret = unlink($fnam);
          $ret=rmdir($fname);        
        }
        else {
          $ret = unlink($fname);
        }
    }
    return ok;
}
function writeNiceUrlTopics($forum,$url)
{
    $query="SELECT m.id AS id,niceurl".
           " FROM forumtopic_zorum t, forummessage_zorum m".
           " WHERE t.pid=".$forum->id." AND niceurl!='' AND m.tid=t.id";
    $result=mysql_query($query);
    if( $result==0 ) {
        $infoText[] = mysql_error();
        return general_mysql_error;
    }
    $num = mysql_num_rows($result);           
    for($i=0;$i<$num;$i++) {
        $row=mysql_fetch_array($result);
        $topic = new ForumTopic;
        $topic->niceurl=$row["niceurl"];
        $ret=createNiceUrlTopic($topic,$forum,$fname);
        $ret=writeNiceUrl($row["id"],$fname,TRUE);
    }
    return ok;
}
function forumtopic_move(&$base)
{
    global $submit;
    global $whatHappened, $infoText;
    global $langTxt;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $ret=$base->load();
    if ($ret!=ok) {
        return $ret;
    }
    $ret = $base->hasObjectRights( $hasRight, Priv_delete, TRUE );
    if ($ret!=ok) {
        $infoText[] = $langTxt["cantDeleteTopic"];
        return $ret;
    } 
    $ret = $base->cacheFatherObject();
    if ($ret!=ok) {
        return $ret;
    }        
    global $fatherForum;
    $oldFatherForum = $fatherForum;
    global $targetForum;
    if( !isset($targetForum) || !$targetForum )
    {
        $infoText[] = $langTxt["operation_cancelled, noTargetForum"];
        return ok;
    }
    $base->pid = $targetForum;       
    $ret = $base->hasObjectRights( $hasRight, Priv_create, TRUE );
    if ($ret!=ok) {
        $infoText[] = $langTxt["cantCreateTopic"];
        return $ret;
    } 
    $ret = $base->cacheFatherObject();
    if ($ret!=ok) {
        return $ret;
    }        
    $ret = modify($base);    
    if ($ret!=ok) {
        return $ret;
    }        
    $query="SELECT COUNT(*) FROM forummessage_zorum WHERE tid=$base->id";
    $result=mysql_query($query);
    if( $result==0 ) {
        $infoText[] = mysql_error();
        return general_mysql_error;
    }
    $row=mysql_fetch_row($result);
    $messageNum = $row[0];
    $oldFatherForum->topicnum--;
    $oldFatherForum->postnum = 
                    max($oldFatherForum->postnum - $messageNum, 0 );
    $ret = modify($oldFatherForum);    
    if ($ret!=ok) {
        return $ret;
    }        
    $fatherForum->topicnum++;
    $fatherForum->postnum += $messageNum;
    $ret = modify($fatherForum);    
    if ($ret!=ok) {
        return $ret;
    }        
    $query = "UPDATE forummessage_zorum SET pid='$targetForum' ".
             "WHERE tid='$base->id'";   
    $result=mysql_query($query);
    if( $result==0 ) {
        $infoText[] = mysql_error();
        return general_mysql_error;
    }
    $query = "UPDATE poll_zorum SET pid='$targetForum' ".
             "WHERE tid=$base->id";   
    $result=mysql_query($query);
    if( $result==0 ) {
        $infoText[] = mysql_error();
        return general_mysql_error;
    }
}
?>
