<?php
function generTextField($type,$name,$label,$explText,$value="",$size="",
                        $maxlength="",$tdCl="", $spanCl="")
{
    global $showExplanation,$langTxt;
    $value=htmlspecialchars($value);
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><td";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><span class='$spanCl'>$label</span>";
    if($explText!="" && $showExplanation=="expl_text") {
        $s.="<br><span class='explanationText'>$explText</span>";
    }
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td><td>\n";
    $s.="<input type='$type' name='$name'";
    if ($value!="") $s.=" value=\"$value\"";
    if ($size!="") $s.=" size='$size'";
    if ($maxlength!="") $s.=" maxlength='$maxlength'";
    $s.=">\n";
    $s.="</td></tr>\n";
    return $s;
}
function generTextAreaField($name,$label,$explText,$value="",$rows="",
                            $cols="",$tdCl="", $spanCl="")
{
    global $showExplanation,$langTxt;
    $value=htmlspecialchars($value);
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.="><td valign=\"center\"";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.="><span class='$spanCl'>$label</span>";
    if($explText!="" && $showExplanation=="expl_text") {
        $s.="<br><span class='explanationText'>$explText</span>";
    }    
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td><td>\n";
    $s.="<textarea name=\"$name\"";
    if ($rows!="") $s.=" rows=\"$rows\"";
    if ($cols!="") $s.=" cols=\"$cols\"";
    $s.=">\n";
    if ($value!="") $s.=$value;
    $s.="</textarea>";
    $s.="</td></tr>\n";
    return $s;
}
function generButtonField($type,$name="",$value="",$class="")
{
    $value=htmlspecialchars($value);
    $s="";
    $s.="<tr";
    if ($class!="") $s.=" class=\"$tdCl\"";
    $s.="><td align=\"center\" colspan=\"2\" class=\"$class\">\n";
    $s.="<input type=\"$type\"";
    if ($value!="") $s.=" value=\"$value\"";
    if ($name!="") $s.=" name=\"$name\"";
    $s.=">\n";
    $s.="</td></tr>\n";
    return $s;
}
function generSelectField($name,$label,$explText,$labels,$values,$selected=0,$multiple=FALSE,$size=0,$tdCl="", $spanCl="",$newTr=TRUE)
{
    global $showExplanation,$langTxt;
    $s="";
    if ($newTr) $s.="<tr class=\"$tdCl\">";
    $s.="<td class=\"$tdCl\"><span class='$spanCl'>$label</span>\n";
    if($explText!="" && $showExplanation=="expl_text")
    {
        $s.="<br><span class='explanationText'>$explText</span>";
    }    
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td><td class=\"$tdCl\">\n";
    $s.="<select name=\"$name\"";
    if ($multiple) $s.=" multiple";
    if ($size>0) $s.=" size=\"$size\"";
    $s.=">\n";
    foreach($labels as $key=>$label ){
        $values[$key]=htmlspecialchars($values[$key]);
        $s.="<option value=\"".$values[$key]."\"";
        if ((gettype($selected)=="array" && $selected[$key]) ||
            $key==$selected)
        {
            $s.=" selected";
        }
        $s.=">$label</option>\n";
    }
    $s.="</select>\n";
    $s.="</td>\n";
    if ($newTr) $s.="</tr>\n";
    return $s;
}
function generReadonlyField($label,$value,$tdCl="", $spanCl="")
{
    $value=htmlspecialchars($value);
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.="><td";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.="><span class='$spanCl'>$label</span></td>\n";
    $s.="</td>\n";
    $s.="<td";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.=">$value</td>\n";
    $s.="</tr>\n";
    return $s;
}
function generBox($content,$linesClass,$width="")
{
    $s="";
    $s.="<table border='0' class='$linesClass'";
    if ($width!="") $s.= " width='$width'";
    $s.=" cellpadding='0' cellspacing='0'>".
        "<tr><td class='$linesClass'>\n";
    $s.="<table border='0' class='$linesClass' width='100%'".
        " cellpadding='2' cellspacing='1'>\n";
    $s.=$content;
    $s.="</table>\n</td></tr></table>\n";
    return $s;
}
function generFileField($name,$label,$explText,$value="",$size="",$maxlength="",$tdCl="", $spanCl="")
{
    global $showExplanation,$langTxt;
    $value=htmlspecialchars($value);
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.="><td";
    if ($tdCl!="") $s.=" class=\"$tdCl\"";
    $s.="><span class='$spanCl'>$label</span>";
    if($explText!="" && $showExplanation=="expl_text")
    {
        $s.="<br><span class='explanationText'>$explText</span>";
    }    
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td><td>\n";
    $s.="<input type=\"FILE\" name=\"$name\"";
    if ($size!="") $s.=" size=\"$size\"";
    if ($maxlength!="") $s.=" maxlength=\"$maxlength\"";
    $s.=">\n";
    $s.="</td></tr>\n";
    return $s;
}
function generGroupSelection($fromListTitle, $toListTitle, 
                             $fromListNames, $toListNames,
                             $fromListValues, $toListValues,
                             $fromListResult, $toListResult,
                             $fromListSize, $toListSize,
                             $addButtonText, $removeButtonText,
                             $addAllButtonText, $removeAllButtonText,
                             $tdCl="", $spanCl="")
{
    global $langTxt;
    $s="<table border='0'>\n";
    $s.="<tr>";
    $s.="<td align='center'>";
    $s.="<span class='$spanCl'>$fromListTitle</span>";
    $s.="</td>\n";
    $s.="<td>";
    $s.="&nbsp;";
    $s.="</td>\n";
    $s.="<td  align='center'>";
    $s.="<span class='$spanCl'>$toListTitle</span>";
    $s.="</td>";
    $s.="</tr>\n";
    $s.="<tr>";
    $s.="<td align='center'>";
    $s.="<select name='$fromListResult' size='$fromListSize' multiple>\n";
    $length = count($fromListValues);
    if( $length )
    {
        foreach( $fromListValues as $key=>$value )
        {
            $s.="<option value='".$value."'>".$fromListNames[$key]."</option>\n";
        }
    }
    else $s.="<option value='0'>".$langTxt["emptyList"]."</option>\n";    
    $s.="</select>\n";
    $s.="</td>\n";
    $s.="<td align='center'>\n";
    $s.="<input type='submit' value='$addButtonText' name='submit'><p>\n";
    $s.="<input type='submit' value='$removeButtonText' name='submit'><p>\n";
    $s.="<input type='submit' value='$addAllButtonText' name='submit'><p>\n";
    $s.="<input type='submit' value='$removeAllButtonText' name='submit'>\n";
    $s.="</td>\n";
    $s.="<td align='center'>";
    $s.="<select name='$toListResult' size='$toListSize' multiple>\n";
    $length = count($toListValues);
    if( $length )
    {
        foreach( $toListValues as $key=>$value )
        {
            $s.="<option value='".$value."'>".$toListNames[$key]."</option>\n";
        }
    }    
    else $s.="<option value='0'>".$langTxt["emptyList"]."</option>\n";        
    $s.="</select>\n";
    $s.="</td>";
    $s.="</tr>";
    $s.="</table>\n";
    return $s;
}
function generMultipleSelection($label, $explText, $listNames, 
                                $listValues, $selected, $listResult, $listSize, 
                                $tdCl="", $spanCl="")
{
    global $showExplanation,$langTxt;
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><td";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><span class='$spanCl'>$label</span>";
    if($explText!="" && $showExplanation=="expl_text") {
        $s.="<br><span class='explanationText'>$explText</span>";
    }
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td><td>\n";
    $s.="<select name='$listResult"."[]' size='$listSize' multiple>\n";
    $length = count($listValues);
    if( $length )
    {
        $selected = split( ", *", $selected );
        foreach( $listValues as $key=>$value )
        {
            $s.="<option value='".$value."'";
            if( in_array($value, $selected) )
            {
                $s.=" selected";
            }
            $s.=">".$listNames[$key]."</option>\n";
        }
    }
    else $s.="<option value='0'>".$langTxt["emptyList"]."</option>\n";    
    $s.="</select>\n";
    $s.="</td></tr>\n";
    return $s;
}
function generSimpleDateField($name,$label,$explText,$value, 
                              $tdCl="", $spanCl="")
{
    global $showExplanation,$langTxt;
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><td";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><span class='$spanCl'>$label</span>";
    if($explText!="" && $showExplanation=="expl_text") {
        $s.="<br><span class='explanationText'>$explText</span>";
    }
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td>\n";
    $s.="<td>";
    $s.=generDateWidget($name, $value, $spanCl);
    $s.="</td></tr>\n";
    return $s;
}
function generComplexDateField($name,$label,$explText,$value,
                               $labels,$values,$selected=0, 
                               $tdCl="", $spanCl="")
{
    global $showExplanation,$langTxt;
    $s="";
    $s.="<tr";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><td";
    if ($tdCl!="") $s.=" class='$tdCl'";
    $s.="><span class='$spanCl'>$label</span>";
    if($explText!="" && $showExplanation=="expl_text") {
        $s.="<br><span class='explanationText'>$explText</span>";
    }
    if($explText!="" && $showExplanation=="expl_qhelp") {
        $s.=" <img src='i/qhelp.gif' width='15' height='15'".
            " alt=\"$langTxt[quickhelp] : $explText\"".
            " title=\"$langTxt[quickhelp] : $explText\">";
    }
    $s.="</td>\n";
    $s.="<td>";
    $s.="<table cellpadding='5' cellspacing='5'><tr><td valign='top'>";
    $s.="<select name='".$name."_relative'>\n";
    foreach($labels as $key=>$label ){
        $values[$key]=htmlspecialchars($values[$key]);
        $s.="<option value=\"".$values[$key]."\"";
        if ((gettype($selected)=="array" && $selected[$key]) ||
            $key==$selected)
        {
            $s.=" selected";
        }
        $s.=">$label</option>\n";
    }
    $s.="</select>\n";
    $s.="<span class='$spanCl'>, <br>".$langTxt["orSelectConcreteTime"].
        ":</span>";
    $s.="</td><td>";
    $s.=generDateWidget($name, $value, "vertical", $spanCl);
    $s.="</td></tr></table></td></tr>\n";
    return $s;
}
function generDateWidget($name, $value, $alignment="horizontal", $spanCl="")
{
    global $langTxt;    
    $s="";
    $date = $value ? getdate($value) : getdate(time());
    if( $alignment=="vertical" ) 
    {
        $s.="<table><tr><td>";
        $s.="<span class='$spanCl'>".$langTxt["year"].": </span>";
        $s.="</td><td>";
        $s.="<select name='".$name."_year'>\n";
        for( $i=2001; $i<2021; $i++ ){
            $s.="<option value='$i'";
            if($date["year"]==$i)
            {
                $s.=" selected";
            }
            $s.=">$i</option>\n";
        }
        $s.="</select>\n";
        $s.="</td></tr><tr><td>";
        $s.="<span class='$spanCl'>".$langTxt["month"].": </span>";
        $s.="</td><td>";
        $s.="<select name='".$name."_month'>\n";
        for( $i=1; $i<13; $i++ ){
            $s.="<option value='$i'";
            if($date["mon"]==$i)
            {
                $s.=" selected";
            }
            $s.=">".$langTxt["month_$i"]."</option>\n";
        }
        $s.="</select>\n";
        $s.="</td></tr><tr><td>";
        $s.="<span class='$spanCl'>".$langTxt["day"].": </span>";
        $s.="</td><td>";
        $s.="<select name='".$name."_day'>\n";
        for( $i=1; $i<32; $i++ ){
            $s.="<option value='$i'";
            if($date["mday"]==$i)
            {
                $s.=" selected";
            }
            $s.=">$i</option>\n";
        }
        $s.="</select>\n";
        $s.="</td></tr></table>";
    }
    else
    {
        $s.="<span class='$spanCl'>".$langTxt["year"].": </span>";
        $s.="<select name='".$name."_year'>\n";
        for( $i=2001; $i<2021; $i++ ){
            $s.="<option value='$i'";
            if($date["year"]==$i)
            {
                $s.=" selected";
            }
            $s.=">$i</option>\n";
        }
        $s.="</select>\n";
        $s.="<span class='$spanCl'>, ".$langTxt["month"].": </span>";
        $s.="<select name='".$name."_month'>\n";
        for( $i=1; $i<13; $i++ ){
            $s.="<option value='$i'";
            if($date["mon"]==$i)
            {
                $s.=" selected";
            }
            $s.=">".$langTxt["month_$i"]."</option>\n";
        }
        $s.="</select>\n";
        $s.="<span class='$spanCl'>, ".$langTxt["day"].": </span>";
        $s.="<select name='".$name."_day'>\n";
        for( $i=1; $i<32; $i++ ){
            $s.="<option value='$i'";
            if($date["mday"]==$i)
            {
                $s.=" selected";
            }
            $s.=">$i</option>\n";
        }
        $s.="</select>\n";
    }
    return $s;
}
?>
