<?php
class Object
{
    function & getTypeInfo()
    {
        $typ = get_class($this)."_typeInfo";
        global ${$typ};
        return ${$typ};
    }
    function getClass()
    {
        return get_class($this);
    }
    function removeFromTypeInfo($attr,$setting)
    {
        $typ= & $this->getTypeInfo();
        $found=FALSE;
        for($i=0;isset($typ["attributes"][$attr][$i]);$i++) {
            if ($typ["attributes"][$attr][$i]==$setting) {
                $found=TRUE;
                break;
            }
        }
        if ($found) unset($typ["attributes"][$attr][$i]);
        return $found;
    }
    function init( $members="" )
    {
        $typ = $this->getTypeInfo(); 
        $attributes = array_keys( $typ["attributes"] );
        if( $members=="" )
        {
            foreach( $attributes as $attribute )
            {
                if(in_array("not null", $typ["attributes"][$attribute]))
                {
                    $this->{$attribute} = 
                        $this->getDefault($typ, $attribute);
                }
                else
                {
                    unset($this->{$attribute});
                }
            }
        }
        else
        {
            foreach( $members as $attribute=>$value )
            {
                if( isset($members[$attribute]) && 
                    in_array($attribute, $attributes) )
                {
                    $this->{$attribute} = $value;
                }
                else if( !isset($members[$attribute]) )
                {
                    unset($this->{$attribute});
                }
            }
        }
    }
    function valid($where="")
    {
        return object_valid($this, $where);
    }
    function getDefault( $typ, $attribute )
    {
        if( !isset( $typ["attributes"][$attribute] ) ) 
        {
            return "";
        }
        else $attrInfo = & $typ["attributes"][$attribute];
        if( isset($attrInfo["default"]) )
        {
            return $attrInfo["default"];
        }
        if( ereg("INT", $attrInfo["type"]) )
        {
            return 0;
        }
        if( ereg("CHAR", $attrInfo["type"]) )
        {
            return "";
        }
        if( ereg("TEXT", $attrInfo["type"]) )
        {
            return "";
        }
        if( $attrInfo["type"]=="ENUM" )
        {
            return $attrInfo["values"][0];
        }
    }
    function validAttribute( $typ, $attribute )
    {
        global $errTxt;
        global $langTxt;
        global $infoText;
        global $whatHappened;
        $value = $this->{$attribute};
        if( !isset( $typ["attributes"][$attribute] ) ) 
        {
            return ok;
        }
        else $attrInfo = & $typ["attributes"][$attribute];
        $className = $this->getClass();
        $attrName = "";
        if (isset($langTxt[$className."_".$attribute])) 
        {
            $attrName=$langTxt[$className."_".$attribute];
        }
        else if( isset($langTxt[$attribute]) ) 
        {        
            $attrName=$langTxt[$attribute];
        }    
        if( ereg("INT", $attrInfo["type"]) )
        {
            if( gettype($value)!="integer" )
            {
                $ret = settype( $value, "integer" );
                if( !$ret )
                {
                    $infoText[] = sprintf( $langTxt["mustBeInt"], 
                                        $attrName );
                    $whatHappened = "invalid_form";                    
                    return ok;
                }
            }
            if( isset($attrInfo["min"]) && $value<$attrInfo["min"] )
            {
                $infoText[] = sprintf( $langTxt["mustBeGreaterInt"], 
                                    $attrName, $attrInfo["min"] );
                $whatHappened = "invalid_form";                    
                return ok;
            }
            if( isset($attrInfo["max"]) && $value>$attrInfo["max"] )
            {
                $infoText[] = sprintf( $langTxt["mustBeSmallerInt"], 
                                    $attrName, $attrInfo["max"] );
                $whatHappened = "invalid_form";                    
                return ok;
            }
            return ok;
        }
        if( ereg("CHAR", $attrInfo["type"]) )
        {
            if( gettype($value)!="string" )
            {
                $infoText[] = sprintf( $langTxt["mustBeString"], 
                                    $attrName );
                $whatHappened = "invalid_form";                    
                return ok;
            }
            if( isset($attrInfo["min"]) &&
                strlen($value)<$attrInfo["min"] )
            {
                $infoText[] = sprintf( $langTxt["mustBeGreaterString"], 
                                    $attrName, $attrInfo["min"] );
                $whatHappened = "invalid_form";                    
                return ok;
            }
            if( isset($attrInfo["max"]) && 
                strlen($value)>$attrInfo["max"] )
            {
                $infoText[] = sprintf( $langTxt["mustBeSmallerString"], 
                                    $attrName, $attrInfo["max"] );
                $whatHappened = "invalid_form";                    
                return ok;
            }
            return ok;
        }
        if( $attrInfo["type"]=="ENUM" )
        {
            if( (gettype($value)=="string" && 
                !in_array($value, $attrInfo["values"])) ||
                (gettype($value)=="integer" && 
                ($value<0 || $value>= sizeof($attrInfo["values"]))) )
            {
                $whatHappened = "invalid_form";                    
                return ok;
            }
            return ok;
        }
        if( $attrInfo["type"]=="SET" )
        {
            if( (gettype($value)=="string" && 
                !in_array($value, $attrInfo["values"])) ||
                (gettype($value)=="array" && 
                sizeof(array_diff($value, $attrInfo["values"]))>0) )
            {
                $whatHappened = "invalid_form";                    
                return ok;
            }
            return ok;
        }
    }
    function copy( $base, $whereFields="" )
    {
        $typ = $this->getTypeInfo();
        if( $whereFields=="" ) $whereFields=getPrimaryKey($typ);
        foreach( $whereFields as $attribute )
        {
            if( isset($base->{$attribute}) ) 
            {
                $this->{$attribute} = $base->{$attribute};
            }
            else
            {
                unset($this->{$attribute});
            }
        }
    }
    function compare( $base, &$differentAttributes )
    {
        $object_vars = get_object_vars($base);
        $differentAttributes = array();
        foreach( $object_vars as $attribute=>$value )
        {
            if( !isset($this->{$attribute}) ||
                $this->{$attribute} != $value) 
            {
                $differentAttributes[] = $attribute;
            }
        }
    }
function createTable()
{
    return createTable( $this );
}   
function dropTable()
{
    return dropTable($this);
}   
function loadSQL( $query="") 
{
    return loadSQL( $this, $query) ;
}   
function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
{
    $hasRight = FALSE;
    if( $giveError )
    {
        global $infoText;
        global $errTxt;
        $txt = $errTxt[permission_denied];
        $infoText[] = $txt;
        return permission_denied;
    }
    return ok;
} 
function hasAdminRights( &$hasRight, $method="" )
{
    return hasAdminRights( $hasRight, $this, $method );
}   
function hasGeneralRights(&$rights)
{
    return hasGeneralRights($this, $rights);
}   
function load( $whereFields="",$whatFields="*",$overrulePrivilege=FALSE) 
{
    return privilegeLoad($this, $whereFields,$whatFields, 
                         $overrulePrivilege) ;
}   
function loadObjectsSQL($query, &$objArr, $overrulePrivilege=FALSE) 
{
    return loadObjectsSql($this, $query, $objArr );
}   
function create($overrulePrivilege=FALSE)
{
    return privilegeCreate($this, $overrulePrivilege);
}   
function modify( $whereFields="", $overrulePrivilege=FALSE )
{
    return privilegeModify( $this, $whereFields, $overrulePrivilege );
}   
function delete( $whereFields="", $overrulePrivilege=FALSE )
{
    return privilegeDelete( $this, $whereFields, $overrulePrivilege );
}   
function loadHtmlList(&$list)
{
    return loadHtmlList($this,$list);
}    
function loadHtmlList(&$list)
{
    return loadHtmlList($this,$list);
}    
function showHtmlList(&$s)
{
    return showHtmlList($this,$s);
}    
function showNavBar(&$s)
{
    $s="";
}    
function showJumperTool(&$s)
{
    $s="";
}    
function showOneRow($rights,&$s)
{
    return showOneRow($this,$rights,$s);
}    
function showTools($rights,&$s)
{
    return showTools($this,$rights,$s);
}    
function showListHeader($isEmpty=FALSE)
{
    return showListHeader($this, $isEmpty);
}    
function showListEntry($rights)
{
    return showListEntry($this, $rights);
}    
function showSortTool($attr)
{
    return showSortTool($this, $attr);
}    
function showDelTool(&$s, $rights,$from="showHtmlList")
{
    return showDelTool($this, $s, $rights, $from);
}    
function showListVal($attr)
{
    return htmlspecialchars($this->{$attr});
}    
function showDetails(&$s, $whereFields="", $withLoad=TRUE)
{
    return showDetails($this,$s, $whereFields, $withLoad);
}    
function showNewTool(&$s, $rights)
{
    return showNewTool($this,$s,$rights);
}
function showModTool(&$s, $rights)
{
    return showModTool($this,$s,$rights);
}
function showNewToolPlusUrl(&$roll)
{
    return ok;
}    
function showHtmlListTitle(&$s)
{
    $s="";
    return ok;
}
function initGlobals()
{
    return ;
}
function generForm(&$s)
{
    return generForm($this,$s);
}
function showObjectTools(&$s)
{
    $s="";
    return ok;
}
function showDetailsMethods()
{
    return "";
}
function treeOrganiserForm(&$s, $filledFromSavedValues=TRUE)
{
    return treeOrganiserForm($this, $s, $filledFromSavedValues);
}
function treeOrganiserServ(&$s)
{
    return treeOrganiserServ($this, $s);
}
function modifyForm(&$s)
{
    if( get_class($this)=="user" && $this->id==0 )
    {
        $ret=$this->load(array("name"));
    }
    else $ret=$this->load();
    if ($ret!=ok) 
    {
        return $ret;
    }
    $ret=$this->hasObjectRights($hasRight, Priv_modify, TRUE);
    if ($ret!=ok) 
    {
        return $ret;
    }
    $ret=$this->generForm($s);
    return ok;
}
function modifyFormInvalid(&$s)
{
    global $whatHappened;
    $ret=$this->generForm($s);
    return $ret;
}
function createForm(&$s)
{
    $ret=$this->hasObjectRights($hasRight, Priv_create, TRUE);
    if ($ret!=ok) 
    {
        return $ret;
    }
    $ret=$this->generForm($s);
    return ok;
}
function createFormInvalid(&$s)
{
    global $whatHappened;
    $ret=$this->createForm($s);
    return $ret;
}
function deleteForm(&$s)
{
    global $zorumroll;
    global $langTxt;
    $ret=$this->load();  
    if ($ret!=ok) 
    {
        return $ret;
    }
    $ret=$this->hasObjectRights($hasRight, Priv_delete, TRUE);
    if ($ret!=ok) 
    {
        return $ret;
    }
    $s="";
    goForward( $tempRoll, "formService" );
    $tempRoll->id = $this->id;
    $label = $langTxt["beforeDelete"];
    $s .= $tempRoll->generConfirmation( $label );
    return ok;
}
function showBelowList(&$s) 
{
    $s=""; 
    return ok;
}
function lockObject() 
{
    global $langTxt;
    global $whatHappened;
    global $infoText;
    $whatHappened = "form_submitted";
    $ret=$this->load();    
    if ($ret!=ok) {
        return $ret;
    }                   
    $ret = $this->hasObjectRights($hasRight, Priv_modify, TRUE);
    if ($ret!=ok) {
        return $ret;
    }                   
    if ($this->status=="forum_opened") {
        $this->status="forum_closed";
        $ret=modify($this);    
        if ($ret!=ok) {
            return $ret;
        }   
        $infoText[] = sprintf($langTxt["closed"], $langTxt[get_class($this)]);                
        return ok;
    }
    else {
        $this->status="forum_opened";
        $ret=modify($this);    
        if ($ret!=ok) {
            return $ret;
        }                   
        $infoText[] = sprintf($langTxt["opened"], $langTxt[get_class($this)]);                
        return ok;
    }
}
function showHtmlHeader(&$s)
{
    global $forumHtmlKeywords, $forumHtmlDescription, $forumHtmlTitle;
    global $portalHtmlKeywords, $portalHtmlDescription,$portalHtmlTitle;
    global $zorumroll, $usedInPortal;
    $s = "";
    if( $zorumroll->scriptname=="portal.php" ) 
    {
        if( $portalHtmlKeywords )
        {
            $s.="<META NAME='keywords' CONTENT='$portalHtmlKeywords'>\n";
        }
        if( $portalHtmlDescription )
        {
            $s.="<META NAME='description' CONTENT='$portalHtmlDescription'>\n";
        }
        if( $portalHtmlTitle )
        {
            $s.="<TITLE>$portalHtmlDescription</TITLE>\n";
        }
    }
    else
    {
        if( $forumHtmlKeywords )
        {
            $s.="<META NAME='keywords' CONTENT='$forumHtmlKeywords'>\n";
        }
        elseif( $usedInPortal && $portalHtmlKeywords )
        {
            $s.="<META NAME='keywords' CONTENT='$portalHtmlKeywords'>\n";
        }
        if( $forumHtmlDescription )
        {
            $s.="<META NAME='description' CONTENT='$forumHtmlDescription'>\n";
        }
        elseif( $usedInPortal && $portalHtmlDescription )
        {
            $s.="<META NAME='description' CONTENT='$portalHtmlDescription'>\n";
        }
        if( $forumHtmlTitle )
        {
            $s.="<TITLE>$forumHtmlTitle</TITLE>\n";
        }
        elseif( $usedInPortal && $portalHtmlTitle )
        {
            $s.="<TITLE>$portalHtmlTitle</TITLE>\n";
        }
    }
    if( $s ) $s="<head>\n$s</head>\n";
    return ok;
} 
function showHtmlHeader(&$s)
{
    $s = "";
    $ret = $this->showHtmlKeywords($keywords);
    if ($ret!=ok) {
        return $ret;
    }                   
    $ret = $this->showHtmlDescription($description);
    if ($ret!=ok) {
        return $ret;
    }                   
    $ret = $this->showHtmlTitle($title);
    if ($ret!=ok) {
        return $ret;
    }                   
    if( $keywords || $description || $title )
    {
        $s = "<head>\n$keywords$description$title</head>\n";
    }
}
function showHtmlKeywords(&$s)
{
    global $forumHtmlKeywords;
    global $portalHtmlKeywords;
    global $zorumroll, $usedInPortal;
    $s = "";
    if( $zorumroll->scriptname=="portal.php" ) 
    {
        if( $portalHtmlKeywords )
        {
           $s.="<META NAME='keywords' CONTENT='$portalHtmlKeywords'>\n";
        }
    }
    else
    {
        if( $forumHtmlKeywords )
        {
           $s.="<META NAME='keywords' CONTENT='$forumHtmlKeywords'>\n";
        }
        elseif( $usedInPortal && $portalHtmlKeywords )
        {
           $s.="<META NAME='keywords' CONTENT='$portalHtmlKeywords'>\n";
        }
    }
    return ok;
} 
function showHtmlDescription(&$s)
{
    global $forumHtmlDescription;
    global $portalHtmlDescription;
    global $zorumroll, $usedInPortal;
    $s = "";
    if( $zorumroll->scriptname=="portal.php" ) 
    {
        if( $portalHtmlDescription )
        {
            $s.="<META NAME='description' CONTENT='$portalHtmlDescription'>\n";
        }
    }
    else
    {
        if( $forumHtmlDescription )
        {
            $s.="<META NAME='description' CONTENT='$forumHtmlDescription'>\n";
        }
        elseif( $usedInPortal && $portalHtmlDescription )
        {
            $s.="<META NAME='description' CONTENT='$portalHtmlDescription'>\n";
        }
    }
    return ok;
} 
function showHtmlTitle(&$s)
{
    global $forumHtmlTitle;
    global $portalHtmlTitle;
    global $zorumroll, $usedInPortal;
    $s = "";
    if( $zorumroll->scriptname=="portal.php" ) 
    {
        if( $portalHtmlTitle )
        {
            $s.="<TITLE>$portalHtmlTitle</TITLE>\n";
        }
    }
    else
    {
        if( $forumHtmlTitle )
        {
            $s.="<TITLE>$forumHtmlTitle</TITLE>\n";
        }
        elseif( $usedInPortal && $portalHtmlTitle )
        {
            $s.="<TITLE>$portalHtmlTitle</TITLE>\n";
        }
    }
    return ok;
} 
}
function object_valid(&$base, $where="")
{
    $typ = $base->getTypeInfo();
    $object_vars = get_object_vars($base);
    $ret = ok;
    global $whatHappened;
    foreach( $object_vars as $attribute=>$value )
    {
        if( is_object($base->{$attribute}) )
        {
            $ret = $base->{$attribute}->valid();
        }
        else 
        {
            $ret = $base->validAttribute( $typ, $attribute );
        }
        if( $ret || $whatHappened=="invalid_form" ) break;
    }
    return $ret;
}
?>
