<?php
$poll_typeInfo =
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "pid"=>array(
                "type"=>"INT",
                "unsigned",
                "not null",
                "form hidden"
            ),
            "tid"=>array(
                "type"=>"INT",
                "unsigned",
                "not null",
                "form hidden"
            ),
            "question"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "list",
                "not null",
                "sorta"
            ),
            "q1"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "not null"
            ),
            "q2"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "not null"
            ),
            "q3"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q4"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q5"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q6"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q7"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q8"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q9"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "q10"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "creationtime"=>array(
                "type"=>"INT",
                "form invisible",
                "private",
                "list",
                "sorta"
            ),            
            "voted"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "not null",
                "private"
            ),           
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            ),           
            "creator"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "list",
                "not null",
                "form hidden",
                "private",
                "sorta"
            )
        ),
        "primary_key"=>array(
            "id"
        ),
        "tableName"=>"poll_zorum",
        "sorta"=>"question"
    );
class Poll extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumauthlevel, $zorumuser,$zorumroll;
        global $allowAnonymPost;
        global $generalRight;
        $hasRight = FALSE;
        $generalRight = FALSE;
        $t = new ForumTopic;
        $t->pid=$this->pid;
        $ret = $t->cacheFatherObject("forum");
        if ($ret!=ok) {
            return $ret;
        }        
        global $fatherForum;
        hasAdminRights($isAdm);
        if( $isAdm )
        {
            $readRight=TRUE;
            $writeRight=TRUE;
        }
        else
        {
            global $readAccessArr;
            if ($fatherForum && $fatherForum->readgroup ) {
                $ret=readAccessForums();
                if( $ret ) {
                    return $ret;
                } 
                $readRight = isset($readAccessArr[$fatherForum->id]);
            }
            else $readRight=TRUE;
            global $writeAccessArr;
            if ($fatherForum && $fatherForum->writegroup) {
                $ret=writeAccessForums();
                if( $ret ) {
                    return $ret;
                } 
                $writeRight = isset($writeAccessArr[$fatherForum->id]);
            }
            else $writeRight=TRUE;
        }
        if( $method==Priv_load ) 
        {
            $hasRight=$readRight;
            $generalRight = TRUE;
        }
        elseif( $zorumauthlevel==Loginlib_NewUser ) {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }  
        elseif( $zorumauthlevel==Loginlib_GuestLevel && 
                $method==Priv_insert )
        {
            $hasRight=TRUE;
            $generalRight = FALSE;
        }        
        elseif( $zorumauthlevel==Loginlib_GuestLevel && 
                $fatherForum && $fatherForum->allowAnonym=="no" )
        {
            $hasRight=FALSE;
            $generalRight = FALSE;
        }        
        elseif( $zorumauthlevel==Loginlib_GuestLevel && 
                !$fatherForum && $allowAnonymPost=="no" )
        {
            $hasRight=FALSE;
            $generalRight = FALSE;
        }        
        elseif( $zorumauthlevel>Loginlib_GuestLevel && 
                !$zorumrecognised )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }        
        else
        {
            if( $method==Priv_create )
            {
                $hasRight=$writeRight;
                $generalRight = ($zorumroll->class=="forumtopic");
            }
            elseif( $zorumuser->isAdm=="yes" )
            {
                $hasRight=TRUE;
                $generalRight = ($zorumroll->class=="forumtopic");
            }
            elseif( $zorumuser->isMod=="yes" && $this->pid!=0)
            {
                if( $fatherForum )
                {
                    $moderators=split( ", *", $fatherForum->moderator );
                    if( in_array($zorumuser->name, $moderators) )
                    {
                      $hasRight=TRUE;
                      $generalRight=FALSE;
                    }    
                }
            }            
            if( !$hasRight && isset($this->ownerId) && 
                $this->ownerId==$zorumuser->id && $this->voted==0)
            {
                $generalRight = FALSE;
                $hasRight=$writeRight;
            }
            elseif( $method==Priv_insert )
            {
                $generalRight = FALSE;
                $hasRight=$writeRight;
            }
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    } 
    function loadHtmlList(&$list)
    {
        global $zorumroll,$fromforummessageview,$zorumuser;
        $ret = loadHtmlList($this,$list);
        if ($ret==general_mysql_error || $ret==permission_denied) {
            return $ret;
        }
        global $readAccessArr;
        $ret=readAccessForums();
        if( $ret ) {
            return $ret;
        }
        hasAdminRights($isAdm); 
        if( !$isAdm )   
        {
            $newList = array();
            for($i=0;isset($list[$i]);$i++)
            {
                if( !$list[$i]->pid || 
                    isset($readAccessArr[$list[$i]->pid]) )
                {
                    $newList[] = $list[$i];
                }
            }
            $list=$newList;
        }    
        return ok;     
    }
    function showListVal($attr)
    {
        global $langTxt;
        global $zorumuser;        
        global $htmlListForum;
        $s="";
        if( $attr=="question" ) {
            global $subsInfo,$zorumrecognised, $zorumauthlevel;
            if (isset($subsInfo["poll_vote"][$this->id]) ||
                !($zorumrecognised || 
                  $zorumauthlevel==Loginlib_GuestLevel)
               ) 
            {
                goForward( $tempRoll, "showpoll" );
            }
            else
            {
                goForward($tempRoll, "vote");
            }    
            $tempRoll->id = $this->id;
            $s.=$tempRoll->generAnchor(htmlspecialchars($this->{$attr}),
                                       "listItem");
            return $s;
        }        
        elseif( $attr=="creationtime" )
        {
            $s=showTimestamp($this->{$attr});
        }
        else
        {
            $s=htmlspecialchars($this->{$attr});
        }
        $s=insertSpanClass($s, "listItem");
        return $s;
    }    
    function showOnlyPoll(&$s)
    {
        global $whatHappened,$infoText,$langTxt,$zorumroll;
        $s="";
        $vote = new Subscribe;
        $vote->type=poll_vote;
        $vote->classid=$this->id;
        $query="SELECT userid,sent FROM subscribe_zorum".
               " WHERE type=".poll_vote." AND classid=$this->id";
        $result=mysql_query($query);
        if( $result==0 ) {
            return general_mysql_error;
        }
        $num=mysql_num_rows($result);
        for($i=1;$i<=10;$i++) {
            $votes[$i]=0;
        }
        for($i=1;$i<=$num;$i++) {
            $row=mysql_fetch_array($result);
            $votes[$row["sent"]]++;
        }
        if( $zorumroll->class=="poll" )
        {
            $ret=$this->showNavBar($s1);
            if ($ret!=ok) {
                return $ret;
            }
            $s.=$s1;
        }
        $s.="<p>";
        $s.="<table border='0' width='100%' cellpadding='0'".
            " cellspacing='0'><tr><td class='table'>\n";
        $s.="<table border='0' width='100%' cellpadding='2' ".
            "cellspacing='1'>\n";
        $s.="<tr><th colspan='4' class='headerbg'><span class='header'>$this->question";
        global $subsInfo;
        if (isset($subsInfo["poll_vote"][$this->id])) {
            $s.="<br>".$langTxt["voted"];
        }
        $s.="</span></td></tr>\n";
        for($i=1;$i<=10;$i++) {
            $m="q".$i;
            if ($this->{$m}=="") break;
            $v = sprintf ("%01.2f",
                          $num ? ((float)($votes[$i]/$num)*100) : 0);
            $vi = (int)$v*3;
            $s.="<tr><td class='forumrow'><span class='listItem'>".$this->{$m}."</span></td>\n";
            $s.="<td class='forumrow' width='300'>".
                "<img src='i/vote$i.gif' height='10' width='$vi'>".
                "</td>\n";
            $s.="<td class='forumrow'><span class='listItem'>".$votes[$i]."</span></td>\n";
            $s.="<td class='forumrow'><span class='listItem'>";
            $s.="$v%";
            $s.="</span></td></tr>\n";
        }
        $s.="<tr><th colspan='4' class='headerbg'><span class='header'>".
            "$num ".$langTxt["votes"]."</span></td></tr>\n";
        $s.="</table>\n";
        $s.="</td></tr></table>\n";
        return ok;
    }
    function showPoll(&$s)
    {
        global $whatHappened,$infoText,$langTxt,$zorumroll;
        $s="";
        if (isset($this->id)&&$this->id==0&&isset($zorumroll->rollid)) {
            $this->id=$zorumroll->rollid;
        }
        $ret=$this->load();
        if ($ret!=ok) {
            return $ret;
        }
        $ret=$this->showOnlyPoll($s);
        if ($ret!=ok) {
            return $ret;
        }
        return ok;
    }
    function voteOnlyForm(&$s)
    {
        global $whatHappened,$infoText,$langTxt, $zorumroll;
        $s="";
        goForward( $tempRoll, "subscribe" );
        $tempRoll->type = poll_vote;
        $tempRoll->classid = $this->id;
        if( $zorumroll->class=="poll" )
        {
            $ret=$this->showNavBar($s1);
            if ($ret!=ok) {
                return $ret;
            }
            $s.=$s1;
        }
        $s.="<p>";
        $s.="<table border='0' width='100%' cellpadding='0'".
            " cellspacing='0'><tr><td class='table'>\n";
        $s.="<table border='0' width='100%' cellpadding='2' ".
            "cellspacing='1'>\n";
        $s.="<tr><th colspan='2' class='headerbg'><span class='header'>$this->question";
        $s.="</span></td></tr>\n";
        $s.="<FORM METHOD='GET' ".
            "ACTION='$tempRoll->scriptname'>\n";
        $s.=$tempRoll->generHiddenFields();            
        for($i=1;$i<=10;$i++) {
            $m="q".$i;
            if ($this->{$m}=="") break;
            $s.="<tr><td class='forumrow'>";
            $s.="<input type='radio' name='sent' value='$i'></td>\n";
            $s.="<td class='forumrow'><span class='listItem'>".$this->{$m}."</span></td></tr>\n";
        }
        $s.="<tr><th class='headerbg'><input type='submit' value='".
        $langTxt["vote"]."' name='submit'></td>\n";
        goForward( $tempRoll, "showpoll" );
        $tempRoll->id = $this->id;
        $s.="<th class='headerbg'>";
        $s.=$tempRoll->generAnchor($langTxt["viewres"],"header");
        $s.="</td></tr>\n";
        $s.="</FORM>\n";
        $s.="</table>\n";
        $s.="</td></tr></table>\n";
        return ok;
    }
    function voteForm(&$s)
    {
        global $whatHappened,$infoText,$langTxt;
        $s="";
        $ret=$this->load();
        if ($ret!=ok) {
            return $ret;
        }
        $ret = $this->hasObjectRights($hasRight, Priv_insert, FALSE);
        if ($ret!=ok) {
            return $ret;
        }
        if( !$hasRight )
        {
            $ret=$this->showOnlyPoll($s);
            if ($ret!=ok) {
                return $ret;
            }
        }
        else
        {
            $ret=$this->voteOnlyForm($s);
            if ($ret!=ok) {
                return $ret;
            }
        }
        return ok;
    }
    function create($overrulePrivilege=FALSE)
    {
        global $zorumuser, $zorumauthlevel;
        global $whatHappened, $infoText;
        global $zorumroll;
        global $submit;
        global $langTxt;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["cancel"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $this->creator = $zorumauthlevel==Loginlib_GuestLevel ?
                         $langTxt["anonymous"] : $zorumuser->name;
        $ret = privilegeCreate($this, $overrulePrivilege);
        if ($ret || $whatHappened=="invalid_form" ) {
            return $ret;
        }        
        $infoText[] = sprintf($langTxt["created"], 
                              $langTxt["poll"]);
        return ok;     
    } 
    function delete($whereFields="", $overrulePrivilege=FALSE )
    {
        global $submit;
        global $langTxt;
        global $whatHappened, $infoText;
        global $zorumroll;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["no"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $ret = privilegeDelete( $this,$whereFields, $overrulePrivilege);
        if ($ret || $whatHappened=="invalid_form" ) {
            $infoText[] = $langTxt["no_such_object"];
            return ok;
        }        
        if( $this->tid )
        {
            $fatherTopic = new ForumTopic;
            $fatherTopic->id = $this->tid;
            $ret = load($fatherTopic);
            if( $ret==general_mysql_error ) 
            {
                return $ret;
            }
            elseif( $ret==ok )
            {
                $fatherTopic->poll="no";
                $ret = modify($fatherTopic);
                if( $ret ) 
                {
                    return $ret;
                }                
            }        
        }
        $subscribe = new Subscribe;
        $subscribe->classid = $this->id;
        $subscribe->type = poll_vote;
        $ret = delete($subscribe, array("classid", "type"));
        if( $ret ) 
        {
            return $ret;
        }                
        if( $zorumroll->frommethod=="showdetails" )      
        {
            $zorumroll->frommethod = "showhtmllist";
        }
    }
    function showNavBar(&$s)
    {
        global $zorumroll; 
        global $langTxt;
        $s = "";
        goForward( $tempRoll, "forums" );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
        $s.="&nbsp;>&nbsp;";
        if( $zorumroll->method=="showhtmllist" )
        {
            $s.=$langTxt["polls"];
        }
        else
        {
            goForward( $tempRoll, "polls", $this );
            $s.=$tempRoll->generAnchor($langTxt["polls"]);
        }    
        $s=insertSpanClass( $s, "navBar" );
        return ok;
    }
    function getPollQuestion( &$s )
    {
        return poll_getPollQuestion( $this, $s );
    }
    function getPollResult( &$s, $withBars=TRUE )
    {
        return poll_getPollResult( $this, $s, $withBars );
    }
}
?>
