<?php
define("MaxSearchResultNum", 100);
$search_typeInfo =  
    array(
        "attributes"=>array(   
            "words"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "operator"=>array(
                "type"  =>"ENUM",
                "values"=>array( "AND", "OR" ),
                "default"=>"AND",
                "not null"
            ),
            "where"=>array(
                "type"  =>"ENUM",
                "values"=>array( "message","subject"  ),
                "default"=>"message",
                "not null"
            ),
            "forumId"=>array(
                "type"=>"INT",
                "unsigned",
                "not null"
            ),
            "userName"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null"
            ),
            "sortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "creationtime_DESC","creationtime_ASC", 
                                 "creator_ASC", "creator_DESC",
                                 "subject_ASC", "subject_DESC",                                  
                                 "topicsubject_ASC","topicsubject_DESC",
                                 "forumname_ASC", "forumname_DESC"),
                "not null"
            ),
            "resultNum"=>array(
                "type"  =>"ENUM",
                "values"=>array( "50", "25", "100" ),
                "not null"
            ),
            "matches"=>array(
                "type"  =>"ENUM",
                "values"=>array( "all", "onePerTopic" ),
                "not null"
            )
        )
    );
class Search extends Object
{
    function searchForm(&$s)
    {
        global $langTxt,$infoText;
        global $search_typeInfo;
        global $zorumroll;
        $s="";
        $ret=$this->showNavBar($s1);
        if ($ret!=ok) {
            return $ret;
        }
        $s.=$s1;
        $forums = new Forum;
        $query="SELECT id, name FROM forum_zorum ORDER BY treeidx";
        $ret=loadObjectsSQL( $forums,$query,$forums);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["noforumToSearch"];
            return ok;
        }
        elseif( $ret ) {
            return $ret;
        }
        global $readAccessArr;
        $ret=readAccessForums();
        if( $ret ) {
            return $ret;
        } 
        hasAdminRights($isAdm);
        if( !$isAdm )   
        {
            $newList = array();
            foreach( $forums as $forum )
            {
                if (isset($readAccessArr[$forum->id]))
                {
                    $newList[] = $forum;
                }
            }
            $forums=$newList;
        }
        $typ = & $search_typeInfo;
        $typ["attributes"]["forumId"]["type"] = "ENUM";
        $typ["attributes"]["forumId"]["values"][0] = 0;
        foreach( $forums as $forum )
        {
            $typ["attributes"]["forumId"]["values"][$forum->id] = 
                $forum->id;
            $langTxt["search_$forum->id"]=$forum->name;   
        }  
        $zorumroll->method = "showhtmllist_form";
        $ret = generForm($this, $s1);
        $s.=$s1;
        return $ret;
    }
    function loadHtmlList(&$list)
    {   
        global $forummessage_typeInfo;
        global $whatHappened,$infoText,$langTxt,$zorumroll,$zorumuser;
        if( !$this->words )
        {
            $zorumroll->method = "search";
            $whatHappened = "invalid_form";
            $infoText[]=$langTxt["invalidWordLength"];
            return ok;
        }
        $words = split(" ",$this->words);
        foreach( $words as $word )
        for( $i=0; isset($words[$i]); $i++ )
        {
            $words[$i] = trim($words[$i]);
            if( !$words[$i] ) unset($words[$i]);
            elseif( strlen($words[$i])<3 )
            {
                $zorumroll->method = "search";
                $whatHappened = "invalid_form";
                $infoText[]=$langTxt["invalidWordLength"];
                return ok;
            }
        }
        foreach( $words as $word )
        $forummessage_typeInfo["attributes"]["forumname"][]="list";
        $forummessage_typeInfo["attributes"]["topicsubject"][]="list";
        $forummessage_typeInfo[]="notools";
        unset($forummessage_typeInfo["attributes"]["rate"]);
        $query = "SELECT m.id AS id, m.pid AS pid, m.tid AS tid,".
                 "m.subject AS subject,".
                 " m.creationtime AS creationtime,m.creator AS creator".
                 ",f.name AS forumname, t.subject AS topicsubject".
                 " FROM forummessage_zorum m, forum_zorum f,".
                 " forumtopic_zorum AS t".
                 " WHERE m.pid=f.id AND m.tid=t.id AND";
        $query.=" (";
        $first=TRUE;
        foreach( $words as $word ) {
            if( !$first ) $query.=" ".$this->operator." ";
            $first = FALSE;
            $word = addcslashes($word,"'");
            $query.="(m.subject LIKE '%".$word."%'";
            if( $this->where=="message" )
            {
                $query.=" OR txt LIKE '%".$word."%'";
            }
            $query.=")";
        }
        $query.=")";
        if ($this->userName!="") {
            $query.=" AND m.creator='".addslashes($this->userName)."'";
        }
        if ($this->forumId) {
            $query.=" AND m.pid=$this->forumId";
        }
        $slices = explode("_", $this->sortCriteria);
        $attrName = $slices[0];
        $direction = $slices[1];
        $query.=" ORDER BY $attrName $direction";
        if( $attrName!="creationtime" )
        {
            $query.=", creationtime DESC";
        }
        $rn = min($this->resultNum, MaxSearchResultNum);
        $query .= " LIMIT $rn";
        $message = new ForumMessage;
        $ret = loadObjectsSQL($message, $query,$list);
        $noErr = $ret==ok || $ret==not_found_in_db;
        if ($ret!=ok) 
        {
            return $ret;
        }
        if( $this->matches=="onePerTopic" )   
        {
            $topicList = array();
            $newList = array();
            for($i=0;isset($list[$i]);$i++)
            {
                if( !in_array($list[$i]->tid, $topicList) )
                {
                    $topicList[] = $list[$i]->tid;
                    $newList[] = $list[$i];
                }
            }
            $list=$newList;
        }
        global $readAccessArr;
        $ret=readAccessForums();
        if( $ret ) {
            return $ret;
        } 
        hasAdminRights($isAdm);
        if( !$isAdm )   
        {
            $newList = array();
            for($i=0;isset($list[$i]);$i++)
            {
                if (isset($readAccessArr[$list[$i]->pid]))
                {
                    $newList[] = $list[$i];
                }
            }
            $list=$newList;
        }
        return ok;
    }
    function showHtmlList(&$s)
    {
        global $whatHappened, $infoText;
        global $langTxt;
        global $submit;
        global $search_typeInfo;
        global $zorumroll;
        $typ = $search_typeInfo;
        $attrs=$typ["attributes"];
        foreach( $attrs as $attr=>$val ) {
            global $$attr;
            if (isset($$attr)) { 
                $this->{$attr}=$$attr;
                $temp = $$attr;
            }
            else
            {
                $this->{$attr}="";
            }
        }    
        if( $submit==$langTxt["cancel"] )
        {   
            $whatHappened = "form_submitted";
            $infoText[] = $langTxt["operation_cancelled"];
            $zorumroll->words = $this->words;
            $zorumroll->where = $this->where;
            $zorumroll->operator = $this->operator;
            $zorumroll->userName = $this->userName;
            $zorumroll->sortCriteria = $this->sortCriteria;
            $zorumroll->resultNum = $this->resultNum;
            $zorumroll->forumId = $this->forumId;
            $zorumroll->matches = $this->matches;
            return ok;
        }
        $s="";
        $ret = $this->loadHtmlList($list);
        if ($ret!=ok&&$ret!=not_found_in_db) {
            return $ret;
        }
        elseif( $whatHappened=="invalid_form" )
        {
            return ok;
        }
        $s.="<table border='0' width='100%' cellpadding='0'".
            " cellspacing='0'>\n";
        $s.="<tr><td align='left'>";
        $ret=$this->showNavBar($s1);
        if ($ret!=ok) {
            return $ret;
        }
        $s.=$s1;
        $s.="</td>\n";
        $s.="</tr></table>\n";
        $s.="<p>";
        $s.="<table border='0' width='100%' cellpadding='0'".
            " cellspacing='0'><tr><td class='table'>\n";
        $s.="<table border='0' width='100%' cellpadding='2' ".
            "cellspacing='1'>\n";
        $s.= $this->showListHeader();  
        for($i=0;isset($list[$i]);$i++) {
            $ret=$list[$i]->showOneRow(0,$s1);
            if ($ret!=ok) {
                return $ret;
            }
            $s.=$s1;
        }
        $s.="</table>\n";
        $s.="</td></tr></table>\n";
        $s.="<br>";
        if (!isset($list[0])) {
            $s.="<center><span class='listItem'>".$langTxt["emptylist"].
                "</span></center><p>";
        }
        return ok;
    }
    function showNavBar(&$s)
    {
        global $langTxt;
        global $zorumroll;
        $s="";
        goForward( $tempRoll, "forums" );
        $s.=$tempRoll->generAnchor($langTxt["forums"],"navBar");
        $s.="&nbsp;>&nbsp;";
        if ($zorumroll->method=="showhtmllist") 
        {
            goForward( $tempRoll, "mainmenu_3", $this );
            $tempRoll->words = $this->words;
            $tempRoll->where = $this->where;
            $tempRoll->operator = $this->operator;
            $tempRoll->userName = $this->userName;
            $tempRoll->sortCriteria = $this->sortCriteria;
            $tempRoll->resultNum = $this->resultNum;
            $tempRoll->forumId = $this->forumId;
            $tempRoll->matches = $this->matches;
            $s.=$tempRoll->generAnchor($langTxt["refineSearch"]);
        }
        else
        {
            $s.=$langTxt["search_showhtmllist_form"];
        }
        $s=insertSpanClass( $s, "navBar" );
        return ok;
    }
    function getClass()
    {
        global $zorumroll;
        if( $zorumroll->method=="showhtmllist" ) return "forummessage";
        else return "search";
    }
    function & getTypeInfo()
    {
        global $zorumroll;
        if( $zorumroll->method=="showhtmllist" ) $class="forummessage";
        else $class="search";
        $typ = $class."_typeInfo";
        global ${$typ};
        return ${$typ};
    }
    function showSortTool(&$s)
    {
        $s = "";
    }
}
?>
