<?php
$settings_typeInfo =  
    array(
        "attributes"=>array(   
            "userId"=>array(
                "type"=>"INT",
                "unsigned",
                "not null",
                "form hidden",
                "portal",
                "forum"
            ),
            "settings_necessaryAuthLevel"=>array(
                "type"  =>"ENUM",
                "values"=>array( Loginlib_BasicLevel, Loginlib_LowLevel, 
                                 Loginlib_HighLevel ),
                "portal",
                "forum"
            ),
            "settings_blockSize"=>array(
                "type"=>"INT",
                "min" =>"1",
                "forum"
            ),
            "settings_portalBlockSize"=>array(
                "type"=>"INT",
                "min" =>"1",
                "portal"
            ),
            "settings_rangeBlockSize"=>array(
                "type"=>"INT",
                "min" =>"1",
                "forum"
            ),
            "settings_blockSortDirection"=>array(
                "type"  =>"ENUM",
                "values"=>array( "lastBlockFirst", "lastBlockLast" ),
                "forum"
            ),
            "settings_timeOut"=>array(
                "type"=>"INT",
                "min" =>"1",
                "forum"
            ),
            "settings_allowHtmlInPost"=>array(
                "type"  =>"INT",                
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_allowUbbInPost"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_allowSmileyInPost"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_allowAnonymPost"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_regOnlyRate"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_globalTimeZone"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"30",
                "min" =>"1",
                "not null",
                "portal",
                "forum"
            ),
            "settings_globalTimeOffset"=>array(
                "type"  =>"TINYINT",
                "min" =>"-24",
                "max" =>"24",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_userTimeOffset"=>array(
                "type"  =>"TINYINT",
                "min" =>"-24",
                "max" =>"24",
                "not null",
                "portal",
                "forum"
            ),
            "settings_globalHotTopicNum"=>array(
                "type"  =>"INT",
                "unsigned",
                "forum"
            ),
            "settings_homeButtonUrl"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"100",
                "globalparam",
                "not null",
                "forum"
            ),
            "settings_homeButtonLabel"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"30",
                "globalparam",
                "not null",
                "forum"
            ),
            "settings_colorStyle"=>array(
                "type"  =>"INT",
                "portal",
                "forum"
            ),
            "settings_activeTheme"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"50",
                "not null",
                "portal"
            ),
            "settings_fontStyleSheet"=>array(
                "type"  =>"INT",
                "portal",
                "forum"
            ),
            "settings_colorStyleSheet"=>array(
                "type"  =>"INT",
                "portal",
                "forum"
            ),
            "settings_upperTemplate"=>array(
                "type"  =>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null",
                "globalparam",
                "portal",
                "forum"            
            ),
            "settings_lowerTemplate"=>array(
                "type"  =>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null",
                "globalparam",
                "portal",
                "forum"            
            ),
            "settings_forumtopicSortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "subject_ASC", "subject_DESC", "postnum_ASC", 
                                 "postnum_DESC", "viewnum_ASC", "viewnum_DESC", 
                                 "creator_ASC", "creator_DESC",
                                 "lastpost_ASC", "lastpost_DESC"),
                "forum"
            ),
            "settings_forummessageSortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "subject_ASC", "subject_DESC", 
                                 "creationtime_ASC", "creationtime_DESC", 
                                 "creator_ASC", "creator_DESC"),
                "forum"
            ),
            "settings_userSortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "name_ASC", "name_DESC", 
                                 "email_ASC", "email_DESC", 
                                 "postnum_ASC", "postnum_DESC",
                                 "lastClickTime_ASC", "lastClickTime_DESC"),
                "forum"
            ),
            "settings_pollSortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "question_ASC", "question_DESC", 
                                 "creationtime_ASC", "creationtime_DESC", 
                                 "creator_ASC", "creator_DESC"),
                "forum"
            ),
            "settings_boxSortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "title_ASC", "title_DESC", 
                                 "alignment_ASC", "alignment_DESC", 
                                 "status_ASC", "status_DESC", 
                                 "idx_ASC", "idx_DESC"),
                "portal"
            ),
            "settings_groupSortCriteria"=>array(
                "type"  =>"ENUM",
                "values"=>array( "name_ASC", "name_DESC"),
                "globalparam",
                "forum"          
            ),
            "settings_textAreaRows"=>array(
                "type"=>"INT",
                "min" =>"1",
                "forum"
            ),
            "settings_textAreaCols"=>array(
                "type"=>"INT",
                "min" =>"10",
                "forum"
            ),
            "settings_showExplanation"=>array(
                "type"  =>"ENUM",
                "values"=>array( "expl_text","expl_qhelp","no"),
                "portal",
                "forum"
            ),
            "settings_attFileSize"=>array(
                "type"  =>"INT",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_attAllowExt"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"250",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_attForbidExt"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"250",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_adminEmail"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"250",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_clickBankUserName"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"30",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_minPasswordLength"=>array(
                "type"  =>"INT",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_dateFormat"=>array(
                "type"  =>"ENUM",
                "values"=>array( "dd.mm.yyyy", "mm.dd.yyyy", 
                                 "yyyy.mm.dd."),
                "portal",
                "forum"
            ),
            "settings_emailCheck"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_searchEngine"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "forum"
            ),
            "settings_messageView"=>array(
                "type"  =>"ENUM",
                "values"=>array( "tree", "list"),
                "forum"
            ),
            "settings_forumView"=>array(
                "type"  =>"ENUM",
                "values"=>array( "tree", "flat"),
                "forum"
            ),
            "settings_language"=>array(
                "type"  =>"ENUM",
                "values"=>array( "en","hu","gr","es","hr"),
                "portal",
                "forum"
            ),
            "settings_cgiUrl"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"250",
                "globalparam",
                "not null",
                "portal",
                "forum"
            ),
            "settings_forumsInPortal"=>array(
                "type"  =>"TEXT",
                "multiple",
                "size" =>10,
                "resultList"=>"forumsInPortalResult",
                "portal"
            ),
            "settings_forumHtmlTitle"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "globalparam",
                "forum"
            ),
            "settings_forumHtmlKeywords"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "globalparam",
                "forum"
            ),
            "settings_forumHtmlDescription"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "globalparam",
                "forum"
            ),
            "settings_portalHtmlTitle"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "globalparam",
                "portal"
            ),
            "settings_portalHtmlKeywords"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "globalparam",
                "portal"
            ),
            "settings_portalHtmlDescription"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "globalparam",
                "portal"
            ),
            "settings_showMetaTags"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal",
                "forum"
            ),
            "settings_portalNiceUrl"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no"),
                "globalparam",
                "portal"
            )
        ),
        "primary_key"=>"userId",
        "tableName"=>"settings_zorum",
        "submit"=>array("ok", "cancel"/*, "resetDefaults"*/)
    );
class Settings extends Object
{
    function initGlobals( $globalSettingsIncluded=TRUE )
    {
        global $settings_typeInfo;
        $typ = & $settings_typeInfo;
        foreach( array_keys($typ["attributes"]) as $attr )
        {
            if( $attr=="id" || !isset($this->{$attr}) ) continue;
            if( !$globalSettingsIncluded &&
                in_array("globalparam", $typ["attributes"][$attr])) continue;
            $global_name = str_replace("settings_", "", $attr );
            global ${$global_name};
            ${$global_name} = $this->{$attr};
            $val = $this->{$attr};
        } 
        global $zorumrecognised;
        global $zorumauthlevel;
        global $necessaryAuthLevel;
        $zorumrecognised = $zorumauthlevel>=$necessaryAuthLevel;          
    }
    function traceGlobals()
    {
        global $settings_typeInfo;
        $typ = & $settings_typeInfo;
        $s="";
        foreach( array_keys($typ["attributes"]) as $attr )
        {
            if( $attr=="id" ) continue;
            $global_name = str_replace("settings_", "", $attr );
            global ${$global_name};
            $val = ${$global_name};
            $s.="$global_name: $val, ";
        } 
        return $s;
    }
    function resetObject()
    {
        return settings_resetObject($this);
    }
    function load() 
    {
        global $zorumuser;
        global $veryGlobal;
        global $veryVeryGlobal;
        if( $veryVeryGlobal )
        {
            $this->resetObject();
            $veryVeryGlobal = FALSE;
            return ok;
        }
        $this->userId = $veryGlobal ? 0 : $zorumuser->id;
        $ret = load($this);
        if( $ret==general_mysql_error )
        {
            return $ret;
        }
        else if( $ret==not_found_in_db )
        {
            if( $veryGlobal ) $veryVeryGlobal = TRUE;
            else $veryGlobal = TRUE;
            $ret = $this->load();
            if( $ret==general_mysql_error )
            {
                return $ret;
            }
        }
        elseif( $ret==ok )
        {
            $temp = new Settings;
            if( $veryGlobal ) $veryVeryGlobal = TRUE;
            else $veryGlobal = TRUE;
            $ret = $temp->load();
            if( $ret==general_mysql_error )
            {
                return $ret;
            }
            $object_vars = get_object_vars($temp);
            foreach( $object_vars as $attribute=>$value )
            {
                if( !isset($this->{$attribute}) ) 
                    $this->{$attribute} = $value;
            }
        }
        $veryGlobal = FALSE;
        return ok;
    }   
    function modify(&$s, $portal=FALSE) 
    {
        return settings_modify($this,$s, $portal);
    }
    function modifyGlobal(&$s, $portal=FALSE) 
    {
        return settings_modifyGlobal($this,$s, $portal);
    }    
    function generForm(&$s)
    {
        return settings_generForm($this,$s);
    }
    function modifyForm(&$s, $portal=FALSE)
    {
        return settings_modifyForm($this,$s, $portal);
    }    
    function modifyFormInvalid(&$s, $portal=FALSE)
    {
        return settings_modifyFormInvalid($this,$s, $portal);
    }
    function modifyGlobalForm(&$s, $portal=FALSE)
    {
        return settings_modifyGlobalForm($this,$s, $portal);
    }
    function modifyGlobalFormInvalid(&$s, $portal=FALSE)
    {
        return settings_modifyGlobalFormInvalid($this,$s, $portal);
    }    
    function showSettings(&$s)
    {
        return settings_showSettings($this,$s);
    }    
    function showSettingsRecognized()
    {
        return settings_showSettingsRecognized($this);
    }
    function generateFiles()
    {
        return settings_generateFiles($this);
    }
    function generateFilesForm(&$s)
    {
        return settings_generateFilesForm($this, $s);
    }
}    
?>
