<?php
$initUbb=TRUE;
$ubbhandler_typeInfo =
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "ubb"=>array(
                "type"=>"VARCHAR",
                "no column"
            ),
            "ubbBegin"=>array(
                "list",
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "not null"
            ),
            "replacementBegin"=>array(
                "list",
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "ubbEnd"=>array(
                "list",
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "replacementEnd"=>array(
                "list",
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null"
            ),
            "enabled"=>array(
                "list",
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"yes",
                "centered",
                "sorta"
            ),            
            "comment"=>array(
                "type"=>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null",
                "list",
                "sorta"
            ),            
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            ),
            "type"=>array(
                "type"  =>"ENUM",
                "values"=>array( "ubb", "censoring", "smiley" ),
                "private",
                "form hidden"
            )
        ),
        "primary_key"=>array(
            "id"
        ),
        "tableName"=>"ubb_zorum"
    );
$ubbhandler_ubb_typeInfo = $ubbhandler_typeInfo;
$ubbhandler_smiley_typeInfo = $ubbhandler_typeInfo;
$ubbhandler_censoring_typeInfo = $ubbhandler_typeInfo;
class UbbHandler extends Object
{
    function initTypeInfos()
    {
        global $ubbhandler_typeInfo;
        global $ubbhandler_ubb_typeInfo;
        global $ubbhandler_smiley_typeInfo;
        global $ubbhandler_ubb_public_typeInfo;
        global $ubbhandler_smiley_public_typeInfo;
        global $ubbhandler_censoring_typeInfo;
        $ubbhandler_smiley_typeInfo["attributes"]["ubbEnd"][] = "form invisible";
        $ubbhandler_censoring_typeInfo["attributes"]["ubbEnd"][] = "form invisible";
        unset($ubbhandler_smiley_typeInfo["attributes"]["ubbEnd"][0]);
        unset($ubbhandler_censoring_typeInfo["attributes"]["ubbEnd"][0]);
        $ubbhandler_smiley_typeInfo["attributes"]["replacementEnd"][] = "form invisible";
        $ubbhandler_censoring_typeInfo["attributes"]["replacementEnd"][] = "form invisible";
        unset($ubbhandler_smiley_typeInfo["attributes"]["replacementEnd"][0]);
        unset($ubbhandler_censoring_typeInfo["attributes"]["replacementEnd"][0]);
        $ubbhandler_smiley_public_typeInfo = $ubbhandler_smiley_typeInfo;
        $ubbhandler_ubb_public_typeInfo = $ubbhandler_ubb_typeInfo;
        $ubbhandler_smiley_public_typeInfo["attributes"]["replacementBegin"][] = "form invisible";
        $ubbhandler_smiley_public_typeInfo["attributes"]["enabled"][] = "form invisible";
        $ubbhandler_ubb_public_typeInfo["attributes"]["replacementBegin"][] = "form invisible";
        $ubbhandler_ubb_public_typeInfo["attributes"]["enabled"][] = "form invisible";
        unset($ubbhandler_smiley_public_typeInfo["attributes"]["replacementBegin"][0]);
        unset($ubbhandler_smiley_public_typeInfo["attributes"]["enabled"][0]);
        unset($ubbhandler_ubb_public_typeInfo["attributes"]["replacementBegin"][0]);
        unset($ubbhandler_ubb_public_typeInfo["attributes"]["enabled"][0]);
        unset($ubbhandler_ubb_public_typeInfo["attributes"]["ubbEnd"][0]);
        unset($ubbhandler_ubb_public_typeInfo["attributes"]["replacementEnd"][0]);
        $ubbhandler_ubb_public_typeInfo[] = "notools";
        $ubbhandler_smiley_public_typeInfo[] = "notools";
        return ok;
    }
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumuser;
        global $generalRight;
        $generalRight = TRUE;
        if( $zorumrecognised && $zorumuser->isAdm=="yes" )
        {
            $hasRight=TRUE;
        }
        elseif( $method==Priv_load )
        {
            $hasRight=TRUE;
            $generalRight = TRUE;
        }        
        else
        {
            $hasRight=FALSE;
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function getClass()
    {
        global $zorumroll;
        if( $zorumroll->class=="ubbhandler_smiley_public" ||
            $zorumroll->class=="ubbhandler_ubb_public" )
        {
            $class = $zorumroll->class;
        }
        if( $zorumroll->method=="create_form" )
        {
            global $class;            
        }
        else
        {
            $class = isset($this->type) ? "ubbhandler_".$this->type : $zorumroll->class;
            if( !$class ) $class = "ubbhandler"; 
        }
        if( !strstr($class, "ubbhandler") ) 
        {
            return "ubbhandler";
        }    
        return $class;
    }
    function & getTypeInfo()
    {
        global $zorumroll;
        if( $zorumroll->class=="ubbhandler_smiley_public" ||
            $zorumroll->class=="ubbhandler_ubb_public"  )
        {
            $class = $zorumroll->class;
        } 
        else $class = $this->getClass();   
        $typ = $class."_typeInfo";
        global ${$typ};
        return ${$typ};
    }
    function loadObjectsSQL( $query="",&$objArr) 
    {
        return ubbhandler_loadObjectsSQL($this, $query, $objArr);
    }        
    function create($overrulePrivilege=FALSE)
    {
        return ubbhandler_create($this, $overrulePrivilege);
    }  
    function modify($whereFields="", $overrulePrivilege=FALSE)
    {
        return ubbhandler_modify($this, $whereFields, $overrulePrivilege);
    }       
    function delete($whereFields="", $overrulePrivilege=FALSE)
    {
        return ubbhandler_delete($this, $whereFields, $overrulePrivilege);
    }       
    function showNavBar(&$s)
    {
        return ubbhandler_showNavBar($this, $s);
    }
    function showListVal($attr, $rights)
    {    
        return ubbhandler_showListVal($this, $attr, $rights);
    }
    function createForm(&$s,$valid=TRUE)
    {
        global $class;
        if( $class=="ubbhandler_ubb" ) $this->type="ubb";
        elseif( $class=="ubbhandler_smiley" ) $this->type="smiley";
        elseif( $class=="ubbhandler_censoring" ) $this->type="censoring";
        $ret = Object::createForm($s);
        return $ret;
    }
    function showNewTool(&$s, $rights)
    {
        global $zorumroll;
        $s="";
        $ret = ok;
        if( $zorumroll->class!="ubbhandler_smiley_public" &&
            $zorumroll->class!="ubbhandler_ubb_public"  )
        {
            $ret = Object::showNewTool($s, $rights);   
        } 
        return $ret;
    }
}
function applyUbbDecoding( $base, &$s , $noSmilies=FALSE)
{
    global $includeUbbCodeTag;
    if( !isset($base->coding) || !isset($base->smiley) )
    {
        $base->coding="UBB";
        $base->smiley="yes";
    }
    if( $noSmilies ) $base->smiley="no";
    $type = ($base->smiley=="yes") ? 
            array("censoring", "smiley") : array("censoring");
    if( $base->coding=="no" )
    {
        $s=htmlspecialchars($s);
        $s=nl2br($s);
        $s=decodeTxt( $s, $type );
    }
    elseif( $base->coding=="HTML" )
    {
        $s=decodeTxt( $s, $type );
    }
    elseif( $base->coding=="UBB" )
    {
        $type[]="ubb";
        if( !$includeUbbCodeTag )
        {
            $s=htmlspecialchars($s);
            $s=nl2br($s);
            $s = decodeTxt( $s, $type );
            return;
        }
        $splittedTxt = array();
        $splittedTxt[1] = $s;
        $s = "";
        while( isset($splittedTxt[1]) && $splittedTxt[1]!="" )
        {
            $splittedTxt = explode( "[code]", $splittedTxt[1], 2 );
            $splittedTxt[0]=htmlspecialchars($splittedTxt[0]);
            $splittedTxt[0]=nl2br($splittedTxt[0]);
            $s .= decodeTxt( $splittedTxt[0], $type );
            if( isset($splittedTxt[1]) && $splittedTxt[1]!="" )
            {
                $s .= "<pre>";
                $splittedTxt = explode( "[/code]", $splittedTxt[1], 2 );
                $s .= $splittedTxt[0];
                $s .= "</pre>";
            }
        }
    }
    return;
}
function decodeTxt( $s , $type )
{
    global $zorumubbrules;
    foreach( $zorumubbrules as $ubbRule )
    {
        if( $ubbRule->enabled=="no" || 
            !in_array($ubbRule->type, $type)) continue;
        if( isset($ubbRule->ubbEnd) && $ubbRule->ubbEnd!="" )
        {
            $count = substr_count($s, $ubbRule->ubb);
            if( $ubbRule->replacementEnd=="<hr></blockquote>" )
            {
                for( $i=0; $i<$count; $i++ ) 
                    $s.="</blockquote>";
            }
            else
            {
                for( $i=0; $i<$count; $i++ ) 
                    $s.=$ubbRule->replacementEnd;
            }        
        }    
        $s = eregi_replace( $ubbRule->ubbBegin, 
                            $ubbRule->replacementBegin, $s );
       if( isset($ubbRule->ubbEnd) && $ubbRule->ubbEnd!="" ) 
       {    
            $s = eregi_replace( $ubbRule->ubbEnd, 
                                $ubbRule->replacementEnd, $s );
       }                          
    }
    return $s;
}
?>
